<%@ Page Language="C#" %>

<%@ Import Namespace="System.Collections" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat="server" >

public void Login_Click(Object sender, EventArgs E) {

	String dsn = (String) ((Hashtable) Context.GetConfig("custom"))["dsn"];

	SqlConnection conn = new SqlConnection(dsn);
	SqlCommand cmd = new SqlCommand("ValidateUser", conn);

	cmd.CommandType = CommandType.StoredProcedure;

	SqlParameter prmEmail = new SqlParameter("@Email", SqlDbType.NVarChar, 50);
	prmEmail.Value = UserEmail.Text;
	cmd.Parameters.Add(prmEmail);

	SqlParameter prmPassword = new SqlParameter("@Password", SqlDbType.NVarChar, 50);
	prmPassword.Value = UserPass.Text;
	cmd.Parameters.Add(prmPassword);

	SqlParameter prmUserID = new SqlParameter("@LoginID", SqlDbType.Int, 4);
	prmUserID.Direction = ParameterDirection.Output;
	cmd.Parameters.Add(prmUserID);

	try {
		conn.Open();
		cmd.ExecuteNonQuery();
	} 
	catch (Exception e) {
		throw(e);
	}
	finally {
		if (conn.State == ConnectionState.Open)
			conn.Close();
	}

	if ((int) prmUserID.Value > 0 ) {
		// The User ID was found, validate the user
		FormsAuthentication.RedirectFromLoginPage(UserEmail.Text, PersistCookie.Checked);
		Msg.Text = "Credentials were valid!";
	}
	else {
		// Not found or incorrect
		Msg.Text = "Invalid Credentials!<br>Please try again.";
	}
}


</script>

<html>
<head>
	<title>Forms Authentication with SQL</title>

<body>

<form runat=server>
    <h3><font face="Verdana">Login Page</font></h3>

    <table>
        <tr>

        <td>Email:</td>
        <td><ASP:TextBox id="UserEmail" runat=server/></td>
        <td><ASP:RequiredFieldValidator 
            ControlToValidate="UserEmail" 
            Display="Static"
            ErrorMessage="* - Please enter your email address."
            runat=server/>
        </td>

    </tr>
    <tr>    

        <td>Password:</td>
        <td><ASP:TextBox id="UserPass" TextMode="password" runat=server/></td>
        <td><ASP:RequiredFieldValidator 
            ControlToValidate="UserPass" 
            Display="Static"
            ErrorMessage="* - Please enter your password."
            runat=server/>
        </td>
    </tr>
    <tr>

        <td>Persistent Cookie:</td>
        <td><ASP:CheckBox id=PersistCookie runat="server"
            autopostback="true" />
        </td>
        <td></td>
    </tr>

</table>


<input type="submit" OnServerClick="Login_Click" Value="Login" 
                                             runat="server"/><p>
    <asp:Label id="Msg" ForeColor="red" Font-Name="Verdana" 
                                  Font-Size="10" runat=server />

</form>
</body>
</html>