   <%@ Import Namespace="System.Collections" %>
   <%@ Import Namespace="System.Data" %>
   <%@ Import Namespace="System.Data.SqlClient" %>
   <%@ Import Namespace="System.Web.Security" %>
   
   <Script Language="C#" Runat=server >
   
   
       public void Page_Load(Object sender, EventArgs E) {
  
          if (User.Identity.Name != "")
          {
              CurrentUser.Text = "You are currently logged on as: " + User.Identity.Name;
          }
      }
  
      public void Register_Click(Object sender, EventArgs E) {
  
          if(!Page.IsValid)
          {
              Msg.Text = "Page is invalid.<br>Please try again.";
  
              //Cancel further processing.
              return;
          }
  
          String dsn = (String) ((Hashtable) Context.GetConfig("custom"))["dsn"];
  
          SqlConnection conn = new SqlConnection(dsn);
          SqlCommand cmd = new SqlCommand("CreateUser", conn);
  
          cmd.CommandType = CommandType.StoredProcedure;
  
          SqlParameter prmEmail = new SqlParameter("@Email", SqlDbType.NVarChar, 50);
          prmEmail.Value = UserEmail.Text;
          cmd.Parameters.Add(prmEmail);
  
          SqlParameter prmPassword = new SqlParameter("@Password", SqlDbType.NVarChar, 50);
          prmPassword.Value = UserPass.Text;
          cmd.Parameters.Add(prmPassword);
  
          SqlParameter prmUserID = new SqlParameter("@UserID", SqlDbType.Int, 4);
          prmUserID.Direction = ParameterDirection.Output;
          cmd.Parameters.Add(prmUserID);
  
          try {
              conn.Open();
              cmd.ExecuteNonQuery();
          }
          catch (Exception e) {
              Msg.Text = e.ToString();
          }
          finally {
              if (conn.State == ConnectionState.Open)
                  conn.Close();
          }
  
          if ((int) prmUserID.Value > 0 ) {
              // The User ID has been created
              if (User.Identity.Name != "")
                  FormsAuthentication.SignOut();
  
              FormsAuthentication.RedirectFromLoginPage(UserEmail.Text, false);
          }
          else {
              // Not found or incorrect
              Msg.Text = "User has <b>not</b> been created.";
          }
  
      }
  
  
  </Script>
  <html>
  <head>
      <title>Forms Authentication with SQL</title>
  
  <body>
  
  <form runat=server>
      <h3><font face="Verdana">Registration Page</font></h3>
  
      <table>
  
      <tr>
          <td>Email:</td>
          <td><ASP:TextBox id="UserEmail" runat=server/></td>
          <td><asp:RegularExpressionValidator id="RegularExpressionValidator1" runat="server"
              ControlToValidate="UserEmail"
              ValidationExpression="^[\w-]+@[\w-]+\.(com|net|org|edu|mil)$"
              Display="Static">Please enter a valid e-mail address
          </asp:RegularExpressionValidator>
  
          </td>
      </tr>
  
      <tr>
          <td>Password:</td>
          <td><ASP:TextBox id="UserPass" TextMode="password" runat=server/></td>
         <td><ASP:RequiredFieldValidator
             ControlToValidate="UserPass"
             Display="Static"
             ErrorMessage="* - Please enter a password."
             runat=server/>
         </td>
     </tr>
 
     <tr>
         <td>Password (confirm):</td>
         <td><ASP:TextBox id="UserConfirmPass" TextMode="password" runat=server/></td>
         <td><ASP:RequiredFieldValidator
             ControlToValidate="UserPass"
             Display="Dynamic"
             ErrorMessage="* - Please re-enter your password."
             runat=server/>
     <asp:CompareValidator
         id="PassComps"
         ControlToValidate="UserPass"
         ControlToCompare="UserConfirmPass"
         Text="Passwords do not match."
         Type="String"
         runat="server"/>
         </td>
     </tr>
 
 </table>
 
 
 
 <br>
 <input type="submit"
     OnServerClick="Register_Click"
     Value="Register/Update"
     runat="server"/><p>
 
 <p>
 <asp:Label id="CurrentUser"
     ForeColor="red"
     Font-Name="Verdana"
     MaintainState="False"
     Font-Size="10"
     runat=server />
 </p>
 
 <p>
 <asp:Label id="Msg"
     ForeColor="red"
     Font-Name="Verdana"
     MaintainState="False"
     Font-Size="10"
     runat=server />
 </p>
 
 </form>
 </body>
 </html>