<%@ WebService Language="C#" Class="WebAuth" %>
  
using System;
using System.Web;
using System.Web.Services;
using System.Data;
using System.Collections;
using System.Data.SqlClient;
using System.Configuration;
 
 
class WebAuth : WebService {
 
	[WebMethod] 
	public bool Authenticate (string UserEmail, string UserPass) {

		String dsn = ConfigurationSettings.AppSettings["dsn"];

		SqlConnection conn = new SqlConnection(dsn);
		SqlCommand cmd = new SqlCommand("ValidateUser", conn);

		cmd.CommandType = CommandType.StoredProcedure;

		SqlParameter prmEmail = new SqlParameter("@Email", SqlDbType.NVarChar, 50);
		prmEmail.Value = UserEmail;
		cmd.Parameters.Add(prmEmail);

		SqlParameter prmPassword = new SqlParameter("@Password", SqlDbType.NVarChar, 50);
		prmPassword.Value = UserPass;
		cmd.Parameters.Add(prmPassword);

		SqlParameter prmUserID = new SqlParameter("@LoginID", SqlDbType.Int, 4);
		prmUserID.Direction = ParameterDirection.Output;
		cmd.Parameters.Add(prmUserID);

		try {
			conn.Open();
			cmd.ExecuteNonQuery();
		}
		catch (Exception e) {
			//Eat the exception and return false
			return false;
		}
		finally {
			if (conn.State == ConnectionState.Open)
				conn.Close();
		}

		if ((int) prmUserID.Value > 0 ) {
			// The credentials are valid.
			return true;
		}
		else {
			// The credentials are invalid.
			return false;
		}
	}
}
