<%@ WebHandler Class="FileUploadHandler" Language="C#" %>
  
using System;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Security.Principal;
   
   
class FileUploadHandler : IHttpHandler {
  
  	public void ProcessRequest(HttpContext context) {
  		
  		HttpRequest Request   = context.Request;
  		HttpResponse Response = context.Response;
  		
  		WindowsIdentity id;
  
  		try 
  		{
  			id = (WindowsIdentity) context.User.Identity;
  		} 
  		catch (Exception eo) 
  		{
  			Response.Write ("Please enable Integrated Windows Authentication in IIS and the configuration file.");
  			Response.Write (eo.Message);
  			
  			return;
  		}		
  				
  		// First check and see if the user is authenticated
  		if (!id.IsAuthenticated) {
  			Response.Write("<H2>Sorry, this page is for authenticated Windows users only.</H2>");
  			Response.Write("Inform the administrator that Anonymous access must be disabled in IIS");
  			
  			return;
  		}
  
  		HttpFileCollection Files = Request.Files;
  	
  		// If there are no files, just return.
  		if (Files.Count == 0) {
  			Response.Write ("There were no files uploaded.<br>");
  			
  			return;
  		}
  
  		// There is at least one file.
  		try 
  		{	
  			string[] FileNames;
  			string   FileName;
  			string	 SavePath;
  			string	 FileAndPath;
  			string	 UserName; 
  
  			HttpPostedFile File;
  
  			int lastslash;
  			int iLoop;
  
  			FileNames = Files.AllKeys;
  
  			for (iLoop=0; iLoop < Files.Count; iLoop++) {
  				
 
  				File = Files[FileNames[iLoop]];
  
  				// Make sure that the HttpPostedFile object is not empty
  				if (File.FileName != "") {
  					
  					// Get the filename minus the path info
  					lastslash = File.FileName.LastIndexOf(@"\");
  					FileName = File.FileName.Substring(lastslash + 1);
  					
  					// Change the MachineName\UserName to MachineName-UserName
  					UserName = id.Name.Replace('\\','-');
  					
  					SavePath = @"c:\temp\" + UserName + @"\";
  					FileAndPath = SavePath + FileName;
  
  					//  Create the directory
  					if(!Directory.Exists(SavePath))
  						Directory.CreateDirectory(SavePath);
  
  					// Save the file
  					File.SaveAs(FileAndPath.ToLower());
  
  					// Let the user know the file(s) were saved
  					Response.Write("SAVED AS: " + FileAndPath.ToLower() + "<br>");
  				}
  			}
  
  		} 
  		catch (Exception eo) 
  		{
  			Response.Write("<H2>" + eo.Message +"</H2>");
  		}
  			
 	}
 
 	public bool IsReusable {
 		get {return true;}
 	}
 }
