<%@ WebHandler Class="FileDownloadHandler" Language="C#"  %>

using System;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Security.Principal;


class FileDownloadHandler : IHttpHandler {

	public void ProcessRequest(HttpContext context) {
		
		HttpRequest Request   = context.Request;
		HttpResponse Response = context.Response;
		
		WindowsIdentity id;

		try 
		{
			id = (WindowsIdentity) context.User.Identity;
		} 
		catch (Exception eo) 
		{
			Response.Write ("Please enable Integrated Windows Authentication in IIS and the configuration file.");
			Response.Write (eo.Message);
			
			return;
		}		
				
		// First check and see if the user is authenticated
		if (!id.IsAuthenticated) {
			Response.Write("<H2>Sorry, this page is for authenticated Windows users only.</H2>");
			Response.Write("Inform the administrator that Anonymous access must be disabled in IIS");
			
			return;
		}

		string UserName = id.Name.Replace('\\','-');

		
		// If there are no files, just return.
		string FileToGet = Request.QueryString.Get("file");

		if (FileToGet==null) {
			Response.Write ("File parameter was missing!");
			return;
		}

		FileToGet = @"c:\temp\" + UserName + @"\" + FileToGet;

		if (!File.Exists(FileToGet)) {
			Response.Write("File Not Found!");
			return;
		}

		try 
		{	
			Response.Clear();
			Response.WriteFile(FileToGet);
		} 
		catch (Exception eo) 
		{
			Response.Write(eo.Message);
		}
		
		
	}

	public bool IsReusable {
		get {return true;}
	}
}
