<%@ Application Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>


<script runat="server">

public void Application_EndRequest (object Sender, EventArgs E) {

	logInfo ((HttpApplication) Sender);
}


private void logInfo (HttpApplication application) {

	HttpRequest Request   = application.Request;
	HttpResponse Response = application.Response;

	string UserName = Request.ServerVariables["REMOTE_USER"];
	string IP	= Request.ServerVariables["REMOTE_ADDR"];
	string Method   = Request.ServerVariables["REQUEST_METHOD"];
	string Path	= Request.ServerVariables["PATH_INFO"];

	// Only log web service calls
	if (Path.ToLower().IndexOf(".asmx")==-1)
		return;
 
	String dsn = ConfigurationSettings.AppSettings["dsn"];
 
        SqlConnection conn = new SqlConnection(dsn);
        SqlCommand cmd = new SqlCommand("LogAccess", conn);
 
        cmd.CommandType = CommandType.StoredProcedure;

        SqlParameter prmUserName = new SqlParameter("@user_name", SqlDbType.NVarChar, 30);	
        prmUserName.Value = UserName;
        cmd.Parameters.Add(prmUserName);

        SqlParameter prmPath = new SqlParameter("@path", SqlDbType.NVarChar, 255);	
        prmPath.Value = Path;
        cmd.Parameters.Add(prmPath);

        SqlParameter prmMethod = new SqlParameter("@method", SqlDbType.NVarChar, 10);	
        prmMethod.Value = Method;
        cmd.Parameters.Add(prmMethod);

        SqlParameter prmIP = new SqlParameter("@remote_ip", SqlDbType.NVarChar, 15);
        prmIP.Value = IP;
        cmd.Parameters.Add(prmIP);
 
        try {
             conn.Open();
             cmd.ExecuteNonQuery();
        }
        catch (Exception e) {
             // Eat the exception and return 
 	     return;
        }
        finally {
             if (conn.State == ConnectionState.Open)
                 conn.Close();
        }

	return;
}

</script>
