//csc /target:library /r:System.Web.dll /r:System.dll error.cs

using System;
using System.Web;
using System.Diagnostics;
using System.Collections;

public class ErrorHandlerModule : IHttpModule {

    public void Init(HttpApplication application) {
        application.Error += new EventHandler(Application_Error);
    }

    private void WriteEventLog(string logName, string message, EventLogEntryType eventType) {

        if (!EventLog.SourceExists(logName))
            EventLog.CreateEventSource(logName, logName);
     
        EventLog log = new EventLog();

        log.Source = logName;
        log.WriteEntry(message, eventType);
    }

    private void Application_Error(Object source, EventArgs e) {

        HttpApplication application = (HttpApplication)source;
        HttpContext context = application.Context;
	string message = "Url: " + context.Request.Path + "\n" + "Error: " + context.Error.ToString();

        WriteEventLog(context.Request.ApplicationPath, message, EventLogEntryType.Error);
    }

    public void Dispose() {}

}
