<%@ WebHandler Class="FileUploadHandler" Language="VB" %>

Imports System
Imports System.IO
Imports System.Web
Imports System.Web.Security
Imports System.Security.Principal



Class FileUploadHandler
   Implements IHttpHandler
   
   
   Public Sub ProcessRequest(context As HttpContext) Implements IHttpHandler.ProcessRequest
      
      Dim Request As HttpRequest = context.Request
      Dim Response As HttpResponse = context.Response
      
      Dim id As WindowsIdentity
      
      Try
         id = CType(context.User.Identity, WindowsIdentity)
      Catch eo As Exception
         Response.Write("Please enable Integrated Windows Authentication in IIS and the configuration file.")
         Response.Write(eo.Message)
         
         Return
      End Try
      
      ' First check and see if the user is authenticated
      If Not id.IsAuthenticated Then
         Response.Write("<H2>Sorry, this page is for authenticated Windows users only.</H2>")
         Response.Write("Inform the administrator that Anonymous access must be disabled in IIS")
         
         Return
      End If
      
      Dim Files As HttpFileCollection = Request.Files
      
      ' If there are no files, just return.
      If Files.Count = 0 Then
         Response.Write("There were no files uploaded.<br>")
         
         Return
      End If
      
      ' There is at least one file.
      Try
         Dim FileNames() As String
         Dim FileName As String
         Dim SavePath As String
         Dim FileAndPath As String
         Dim UserName As String
         
         Dim File As HttpPostedFile
         
         Dim lastslash As Integer
         Dim iLoop As Integer
         
         FileNames = Files.AllKeys
         
         For iLoop = 0 To Files.Count - 1
                     
            File = Files(FileNames(iLoop))
            
            ' Make sure that the HttpPostedFile object is not empty
            If File.FileName <> "" Then
               
               ' Get the filename minus the path info
               lastslash = File.FileName.LastIndexOf("")
               FileName = File.FileName.Substring((lastslash + 1)) '
               
               ' Change the MachineName\UserName to MachineName-UserName
               UserName = id.Name.Replace("\"c, "-"c)
               
               SavePath = ""
               FileAndPath = SavePath + FileName '

               '  Create the directory
               If Not Directory.Exists(SavePath) Then
                  Directory.CreateDirectory(SavePath)
               End If 
               ' Save the file
               File.SaveAs(FileAndPath.ToLower())
               
               ' Let the user know the file(s) were saved
               Response.Write(("SAVED AS: " + FileAndPath.ToLower() + "<br>"))
            End If
         Next iLoop
      
      Catch eo As Exception
         Response.Write(("<H2>" + eo.Message + "</H2>"))
      End Try
   End Sub 
   
   
   Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
      Get
         Return True
      End Get
   End Property
End Class