<%@ WebHandler Class="FileDownloadHandler" Language="VB" %>

Imports System
Imports System.IO
Imports System.Web
Imports System.Web.Security
Imports System.Security.Principal

 

Class FileDownloadHandler
   Implements IHttpHandler
   
   
   Public Sub ProcessRequest(context As HttpContext) Implements IHttpHandler.ProcessRequest
      
      Dim Request As HttpRequest = context.Request
      Dim Response As HttpResponse = context.Response
      
      Dim id As WindowsIdentity
      
      Try
         id = CType(context.User.Identity, WindowsIdentity)
      Catch eo As Exception
         Response.Write("Please enable Integrated Windows Authentication in IIS and the configuration file.")
         Response.Write(eo.Message)
         
         Return
      End Try
      
      ' First check and see if the user is authenticated
      If Not id.IsAuthenticated Then
         Response.Write("<H2>Sorry, this page is for authenticated Windows users only.</H2>")
         Response.Write("Inform the administrator that Anonymous access must be disabled in IIS")
         
         Return
      End If
      
      Dim UserName As String = id.Name.Replace("\"c, "-"c)
      
      
      ' If there are no files, just return.
      Dim FileToGet As String = Request.QueryString.Get("file")
      
      If FileToGet Is Nothing Then
         Response.Write("File parameter was missing!")
         Return
      End If
      
      FileToGet = "c:\temp\" & UserName & "\" & FileToGet
      
      If Not File.Exists(FileToGet) Then
         Response.Write("File Not Found!")
         Return
      End If
      
      Try
         Response.Clear()
         Response.WriteFile(FileToGet)
      Catch eo As Exception
         Response.Write(eo.Message)
      End Try
   End Sub 
   
   Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
      Get
         Return True
      End Get
   End Property
End Class