<%@ WebHandler Language="VB" Class="ImageHandler" %>

Imports System
Imports System.IO
Imports System.Web
Imports System.Drawing
Imports System.Drawing.Imaging

Class ImageHandler
   Implements IHttpHandler
      
   Public Sub ProcessRequest(context As HttpContext) Implements IHttpHandler.ProcessRequest     
      CreateImage(context)
   End Sub
      
   Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
      Get
         Return True
      End Get
   End Property
    
   Public Sub CreateImage(ByRef context As HttpContext)
      
      Dim Response As HttpResponse = context.Response
      Dim Request As HttpRequest = context.Request
      
      Const FONT_NAME As String = "Courier New"
      Const FONT_SIZE As Integer = 12
      
      Dim bmp As Bitmap
      Dim g As Graphics
      
      Dim RenderText As String = "[TEXT WAS UNDEFINED]"
      
      If Not (Request.QueryString.Get("Text") Is Nothing) And Request.QueryString.Get("Text") <> "" Then
         RenderText = Request.QueryString.Get("Text")
      End If 

      Dim BackgroundColorName As String = Request.QueryString.Get("BGColor")
      
      Dim BackgroundColor As Color = Color.CornflowerBlue
      Try
         If BackgroundColorName <> "" Then
            BackgroundColor = ColorTranslator.FromHtml(BackgroundColorName)
         End If
      Catch
      End Try 
      Try
         Dim font As New Font(FONT_NAME, FONT_SIZE)

         bmp = New Bitmap(1, 1, PixelFormat.Format32bppPArgb)
         g = Graphics.FromImage(bmp)
         Dim sSize As SizeF = g.MeasureString(RenderText, font)
         
         Dim nHeight As Integer = CInt(sSize.Height)
         Dim nWidth As Integer = CInt(sSize.Width)
         bmp = New Bitmap(nWidth, nHeight, PixelFormat.Format32bppPArgb)
         
         g = Graphics.FromImage(bmp)
         g.FillRectangle(New SolidBrush(BackgroundColor), New Rectangle(0, 0, nWidth, nHeight))
         
         g.DrawString(RenderText, font, New SolidBrush(Color.White), 0, 0)
         
         Dim memStream As New MemoryStream()
         
         bmp.Save(memStream, ImageFormat.Png)
         
         Response.Clear()
         
         Response.ContentType = "IMAGE/PNG"
         
         Response.BinaryWrite(memStream.ToArray())
         

         Response.End()
      
      Catch
      
      Finally

         If g Is Nothing Then
            g.Dispose()
         End If 

         If bmp Is Nothing Then
            bmp.Dispose()
         End If
      End Try 
   End Sub
End Class 