<%@ Application Language="C#" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>


<script runat="server">

Public Sub Application_EndRequest(Sender As Object, E As EventArgs)
   
   logInfo(CType(Sender, HttpApplication))
End Sub 'Application_EndRequest

Private Sub logInfo(application As HttpApplication)
   
   Dim Request As HttpRequest = application.Request
   Dim Response As HttpResponse = application.Response
   
   Dim UserName As String = Request.ServerVariables("REMOTE_USER")
   Dim IP As String = Request.ServerVariables("REMOTE_ADDR")
   Dim Method As String = Request.ServerVariables("REQUEST_METHOD")
   Dim Path As String = Request.ServerVariables("PATH_INFO")
   
   ' Only log web service calls
   If Path.ToLower().IndexOf(".asmx") = - 1 Then
      Return
   End If 
   Dim dsn As [String] = ConfigurationSettings.AppSettings("dsn")
   
   Dim conn As New SqlConnection(dsn)
   Dim cmd As New SqlCommand("LogAccess", conn)
   
   cmd.CommandType = CommandType.StoredProcedure
   
   Dim prmUserName As New SqlParameter("@user_name", SqlDbType.NVarChar, 30)
   prmUserName.Value = UserName
   cmd.Parameters.Add(prmUserName)
   
   Dim prmPath As New SqlParameter("@path", SqlDbType.NVarChar, 255)
   prmPath.Value = Path
   cmd.Parameters.Add(prmPath)
   
   Dim prmMethod As New SqlParameter("@method", SqlDbType.NVarChar, 10)
   prmMethod.Value = Method
   cmd.Parameters.Add(prmMethod)
   
   Dim prmIP As New SqlParameter("@remote_ip", SqlDbType.NVarChar, 15)
   prmIP.Value = IP
   cmd.Parameters.Add(prmIP)
   
   Try
      conn.Open()
      cmd.ExecuteNonQuery()
   Catch e As Exception
      ' Eat the exception and return 
      Return
   Finally
      If conn.State = ConnectionState.Open Then
         conn.Close()
      End If
   End Try 
   Return
End Sub 'logInfo

</script>