<%@ Import namespace="System.Runtime.InteropServices" %>
<script language="C#" runat="server">
[DllImport("kernel32.dll")]
static extern bool QueryPerformanceCounter(out long lpPerformanceCount);
[DllImport("kernel32.dll")]
static extern bool QueryPerformanceFrequency(out long lpFrequency);
 
void Page_Load(object sender, EventArgs e)
{
  long CurrentTime;

  if (!Page.IsPostBack)
  {
    lblTime.Text = "";
    CurrentTime = 0;
    Session["LastTime"] = new long();
    Session["Frequency"] = new long();
    long temp;
    if (!QueryPerformanceFrequency(out temp))
    {
      lblTime.Text = "Error: Server doesn't support performance counters";
      btnSubmit.Enabled = false;
    }
    Session["Frequency"] = temp;
  }
  else
  {
    // a postback, so calculate the time elapsed
    if (QueryPerformanceCounter(out CurrentTime) && 
      (long)Session["LastTime"] != 0)
    {
      lblTime.Text = lblTime.Text + ((CurrentTime - 
        (long)Session["LastTime"]) / (long)Session["Frequency"]).ToString()
        + " seconds since last click.<br>";
    }
    else { lblTime.Text = lblTime.Text + "Please click again.<br>"; }
    Session["LastTime"] = CurrentTime;
  }
}
</script>
<html><title>Using Performance Counters in ASP.NET</title>
<body>
  <form method="post" runat="server">
    <b>Test Your Reflexes:</b><br>
    <asp:button id="btnSubmit" runat="server" 
      type="Submit" text="Click Me!" />
    <p><hr><p>
    <asp:label runat="server" id="lblTime" />
  </form>
</body>
</html>
