<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Runtime.InteropServices" %>
<script language="VB" runat="server">
  ' Initializes the AVIFile library.
  Declare Function AVIFileInit Lib "avifil32.dll" () As Integer
   
  ' Exits the AVIFile library.
  Declare Function AVIFileExit Lib "avifil32.dll" () As Integer
   
  ' Opens the specified AVI file and returns a file interface (IAVIFile).
  Declare Function AVIFileOpen Lib "avifil32.dll" (
    ByRef ppfile As IAVIFile, szFile As String, mode As Integer, _
    pclsidHandler As Guid) As Integer
  
  ' Returns a stream interface (IAVIStream) associated with an AVI file.
  Declare Function AVIFileGetStream Lib "avifil32.dll" ( _
    pfile As IAVIFile, ByRef ppavi As IAVIStream, fccType As Integer, _
    lParam As Integer) As Integer
  
  ' Returns the length of the input stream.
  Declare Function AVIStreamLength Lib "avifil32.dll" _
    (pavi As IAVIStream) As Integer
  
  ' Converts a stream measurement in samples to milliseconds.
  Declare Function AVIStreamSampleToTime Lib "avifil32.dll" _
    (pavi As IAVIStream, lSample As Integer) As Integer
  
  '
  ' The IAVIFile COM Interface used in the methods above
  '
  <ComImport(), InterfaceType(ComInterfaceType.InterfaceIsIUnknown), _
    Guid("00020020-0000-0000-c000-000000000046")> Interface IAVIFile
    Sub Info(ByRef pfi As AVIFILEINFO, lSize As Integer)
    Sub GetStream(ByRef ppStream As IAVIStream, fccType As Integer, _
      lParam As Integer)
    Sub CreateStream(ByRef ppStream As IAVIStream, psi As AVISTREAMINFO)
    Sub WriteData(ckid As Integer, lpData As IntPtr, cbData As Integer)
    Sub ReadData(ckid As Integer, lpData As IntPtr, _
      ByRef lpcbData As Integer)
    Sub EndRecord()
    Sub DeleteStream(fccType As Integer, lParam As Integer)
  End Interface
  
  '
  ' The IAVIStream COM Interface used in the methods above
  '
  <ComImport(), InterfaceType(ComInterfaceType.InterfaceIsIUnknown), _
    Guid("00020021-0000-0000-c000-000000000046")> Interface IAVIStream
    Sub Create(lParam1 As Integer, lParam2 As Integer)
    Sub Info(ByRef psi As AVISTREAMINFO, lSize As Integer)
    <PreserveSig> Function FindSample(lPos As Integer, _
      lFlags As Integer) As Integer
    Sub ReadFormat(lPos As Integer, lpFormat As IntPtr, _
      ByRef lpcbFormat As Integer)
    Sub SetFormat(lPos As Integer, lpFormat As IntPtr, _
      cbFormat As Integer)
    Sub Read(lStart As Integer, lSamples As Integer, lpBuffer As IntPtr, _
      cbBuffer As Integer)
    Sub Write(lStart As Integer, lSamples As Integer, _
      lpBuffer As IntPtr, cbBuffer As Integer, dwFlags As Integer, _
      ByRef plSampWritten As Integer, ByRef plBytesWritten As Integer)
    Sub Delete(lStart As Integer, lSamples As Integer)
    Sub ReadData(fcc As Integer, lp As IntPtr, ByRef lpcb As Integer)
    Sub WriteData(fcc As Integer, lp As IntPtr, cb As Integer)
    Sub SetInfo(fcc As Integer, lp As IntPtr, cb As Integer)
  End Interface
  
  '
  ' Structures used in the interfaces above.
  '
  <StructLayout(LayoutKind.Sequential, _
    CharSet:=CharSet.Auto)> Public Structure AVISTREAMINFO
    Public fccType As Integer
    Public fccHandler As Integer
    Public dwFlags As Integer
    Public dwCaps As Integer
    Public wPriority As Short
    Public wLanguage As Short
    Public dwScale As Integer
    Public dwRate As Integer
    Public dwStart As Integer
    Public dwLength As Integer
    Public dwInitialFrames As Integer
    Public dwSuggestedBufferSize As Integer
    Public dwQuality As Integer
    Public dwSampleSize As Integer
    Public rcFrame As RECT
    Public dwEditCount As Integer
    Public dwFormatChangeCount As Integer
    <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=64)> _
    Public szName As String
  End Structure
  
    <StructLayout(LayoutKind.Sequential, _
    CharSet:=CharSet.Auto)> Public Structure AVIFILEINFO
    Public dwMaxBytesPerSec As Integer
    Public dwFlags As Integer
    Public dwCaps As Integer
    Public dwStreams As Integer
    Public dwSuggestedBufferSize As Integer
    Public dwWidth As Integer
    Public dwHeight As Integer
    Public dwScale As Integer
    Public dwRate As Integer
    Public dwLength As Integer
    Public dwEditCount As Integer
      <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=64)> _
    Public szFileType As String
  End Structure
 
    Public Structure RECT
    Public left As Integer
    Public top As Integer
    Public right As Integer
    Public bottom As Integer
  End Structure
 
    ' Constant used when opening the file
  Public OF_SHARE_DENY_WRITE As Integer = 32
 
  Sub Page_Load(sender As [Object], e As EventArgs)
    Dim result as Integer
 
    If Page.IsPostBack AndAlso Not (fupUpload.PostedFile Is Nothing) Then
      ' Save the file if it has a filename and exists...
        If (fupUpload.PostedFile.FileName.Trim().Length > 0 And _
        fupUpload.PostedFile.ContentLength > 0) Then
        Const strBaseDir As String = "C:\My Projects\Uploaded Files\"
          Dim strFileName As String = _
          Path.GetFileName(fupUpload.PostedFile.FileName)
          fupUpload.PostedFile.SaveAs((strBaseDir & strFileName))
 
        Dim pfile As IAVIFile = Nothing
 
          ' Initialize the AVIFile library
        result = AVIFileInit()
        If (result < 0) Then
          lblResults.Text = _
            "<hr>Server Error: Cannot initialize the AVIFile library."
          Exit Sub
        End If
 
          ' Open the AVI file
        result = AVIFileOpen(pfile, strBaseDir & strFileName, _
          OF_SHARE_DENY_WRITE, Guid.Empty)
        If (result < 0) Then
          lblResults.Text = _
            "<hr>The uploaded file is not a valid AVI or WAV file."
          Exit Sub
        End If
 
          ' Display summary information
        Dim fileinfo As New AVIFILEINFO()
 
        ' Call a method on the IAVIFile COM interface
        Try
          pfile.Info(fileinfo, Marshal.SizeOf(fileinfo))
          Catch ex As Exception
          lblResults.Text = "<hr>Unable to get file information."
          Exit Sub
        End Try
 
          Dim samplesPerSecond As Double = _
          fileinfo.dwRate / fileinfo.dwScale
          lblResults.Text = "<hr>Information for file <b>" & _
          fupUpload.PostedFile.FileName & _
          "</b>:<hr>Type: <b>" & fileinfo.szFileType & _
          "</b><br>Width: <b>" & fileinfo.dwWidth & _
          "</b><br>Height: <b>" & fileinfo.dwHeight & _
          "</b><br>Samples/Sec: <b>" & samplesPerSecond & _
          "</b><br># of Streams: <b>" & fileinfo.dwStreams & "</b><br>"
 
          ' Look at each stream and print out summary information
        Dim i As Integer
        For i = 0 To fileinfo.dwStreams - 1
          Dim pstream As IAVIStream = Nothing
 
          result = AVIFileGetStream(pfile, pstream, 0, i)
          If (result < 0) Then
            lblResults.Text = "<hr>Cannot get stream #" & (i+1).ToString()
            Exit Sub
          End If
 
          Dim streaminfo As New AVISTREAMINFO()
 
          ' Call a method on the IAVIStream COM interface
          Try
            pstream.Info(streaminfo, Marshal.SizeOf(streaminfo))
          Catch ex As Exception
            lblResults.Text = "<hr>Cannot get information for stream #" _
              & (i+1).ToString()
            Exit Sub
          End Try
 
          Dim time As Integer = AVIStreamSampleToTime(pstream, _
            AVIStreamLength(pstream))
          Dim seconds As Integer = time / 1000
          Dim fraction As Integer = time Mod 1000
 
          samplesPerSecond = streaminfo.dwRate / streaminfo.dwScale
 
          lblResults.Text += "<hr><b>Stream #" & (i + 1).ToString() & _
            "</b><br>Name: <b>" & streaminfo.szName & _
            "</b><br>Frame Count: <b>" & _
                AVIStreamLength(pstream).ToString() & _
            "</b><br>Play Length: <b>" & seconds.ToString() & _
            "." & fraction.ToString() & " sec" & _
            "</b><br>Samples/Sec: <b>" & samplesPerSecond & "</b><br>"
        Next i
 
          ' Called instead of AVIFileRelease,
          ' since it releases the COM interface.
        Marshal.ReleaseComObject(pfile)
 
          ' Release the AVIFile library
        AVIFileExit()
        Else
        lblResults.Text = "<hr>You must enter a valid filename!"
      End If
    End If
  End Sub 'Page_Load
  </script>
<html>
<body>
  <form runat="server" EncType="multipart/form-data">
    <h1>Multimedia File Upload</h1>
    <b>Select the AVI or WAV file to upload:</b><br>
    <input runat="server" id="fupUpload" type="file" >
    <p>
    <asp:button id="btnSubmit" runat="server" Text="Upload File" />
    <p><asp:label runat="server" id="lblResults" />
  </form>
 </body>
</html>
