<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">
  void Page_Load( Object s, EventArgs e )
  {
    if ( !IsPostBack )
      BindData();
  }

  void BindData()
  {
    SqlConnection myConnection;
    SqlCommand myCommand;
    // Get Records From Database;
    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" );
    myCommand = new SqlCommand( "Select * from Products", myConnection );
    myConnection.Open();
    myDataGrid.DataSource = myCommand.ExecuteReader();
    myDataGrid.DataBind();
    myConnection.Close();
  }

  void editProduct( Object s, DataGridCommandEventArgs e )
  {
    myDataGrid.EditItemIndex = e.Item.ItemIndex;
    BindData();
  }

  void cancelEdit( Object s, DataGridCommandEventArgs e )
  {
    myDataGrid.EditItemIndex = -1;
    BindData();
  }

  void updateProduct( Object s, DataGridCommandEventArgs e )
  {
    // Get New Values
    TextBox productName;
    productName = (TextBox) e.Item.Cells[ 2 ].Controls[ 0 ];
    TextBox unitPrice;
    unitPrice = (TextBox) e.Item.Cells[ 3 ].Controls[ 0 ];

    // Update Database
    SqlConnection myConnection;
    SqlCommand myCommand;
    String sqlString;

    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" );
    sqlString = "Update Products Set ProductName=@productName, UnitPrice=@unitPrice Where ProductID=@productID";
    myCommand = new SqlCommand( sqlString, myConnection );
    myCommand.Parameters.Add( new SqlParameter( "@ProductName", SqlDbType.NVarChar, 80 ));
    myCommand.Parameters[ "@ProductName" ].Value = productName.Text;
    myCommand.Parameters.Add( new SqlParameter( "@unitprice", SqlDbType.Money ));
    myCommand.Parameters[ "@unitPrice" ].Value = Decimal.Parse( unitPrice.Text, System.Globalization.NumberStyles.Currency );
    myCommand.Parameters.Add( new SqlParameter( "@productID", SqlDbType.Int ));
    myCommand.Parameters[ "@productID" ].Value = myDataGrid.DataKeys[ e.Item.ItemIndex ];
    myConnection.Open();
    myCommand.ExecuteNonQuery();
    myConnection.Close();
    myDataGrid.EditItemIndex = -1;
    BindData();
  }
</Script>

<html>
<head><title>DataGrid</title></head>
<body>

<form Runat="Server">

<asp:DataGrid
  id="myDataGrid"
  cellpadding=3
  AutoGenerateColumns="False"
  DataKeyField="ProductID"
  OnEditCommand="editProduct"
  OnCancelCommand="cancelEdit"
  OnUpdateCommand="updateProduct"
  Runat="Server">
  <Columns>
    <asp:EditCommandColumn
      EditText="Edit"
      CancelText="Cancel"
      UpdateText="Update" />
    <asp:BoundColumn HeaderText="Product ID" DataField="ProductID" ReadOnly="True"/>
    <asp:BoundColumn HeaderText="Product Name" DataField="ProductName" />
    <asp:BoundColumn HeaderText="Price" DataField="UnitPrice" DataFormatString="{0:c}" />
  </Columns>
</asp:DataGrid>

</form>

</body>
</html>
