<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">
  void Page_Load( Object s, EventArgs e )
  {
    if ( !IsPostBack )
      BindData();
  }

  void BindData()
  {
    SqlConnection myConnection;
    SqlCommand myCommand;
    String sqlString;
    SqlDataReader myDataReader;
    // Get Records From Database
    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" );
    sqlString = "Select * from Products";
    myCommand = new SqlCommand( sqlString, myConnection );
    myConnection.Open();
    myDataReader = myCommand.ExecuteReader();
    myDataGrid.DataSource = myDataReader;
    myDataGrid.DataBind();
    myConnection.Close();
  }

  void editProduct( Object s, DataGridCommandEventArgs e )
  {
    myDataGrid.EditItemIndex = e.Item.ItemIndex;
    BindData();
  }

  void cancelEdit( Object s, DataGridCommandEventArgs e )
  {
    myDataGrid.EditItemIndex = -1;
    BindData();
  }

  void updateProduct( Object s, DataGridCommandEventArgs e )
  {
    if ( IsValid )
    {
    // Get New Values
    TextBox productName;
    productName = (TextBox) e.Item.FindControl( "ProductName" );
    TextBox unitPrice;
    unitPrice = (TextBox) e.Item.FindControl( "UnitPrice" );

    // Update Database
    SqlConnection myConnection;
    SqlCommand myCommand;
    String sqlString;

    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" );
    sqlString = "Update Products Set ProductName=@productName, UnitPrice=@unitPrice Where ProductID=@productID";
    myCommand = new SqlCommand( sqlString, myConnection );
    myCommand.Parameters.Add( new SqlParameter( "@ProductName", SqlDbType.NVarChar, 80 ));
    myCommand.Parameters[ "@ProductName" ].Value = productName.Text;
    myCommand.Parameters.Add( new SqlParameter( "@unitprice", SqlDbType.Money ));
    myCommand.Parameters[ "@unitPrice" ].Value = Decimal.Parse( unitPrice.Text, System.Globalization.NumberStyles.Currency );
    myCommand.Parameters.Add( new SqlParameter( "@productID", SqlDbType.Int ));
    myCommand.Parameters[ "@productID" ].Value = myDataGrid.DataKeys[ e.Item.ItemIndex ];
    myConnection.Open();
    myCommand.ExecuteNonQuery();
    myConnection.Close();
    myDataGrid.EditItemIndex = -1;
    BindData();
    }
  }
</Script>

<html>
<head><title>DataGrid</title></head>
<body>

<form Runat="Server">

<asp:DataGrid
  id="myDataGrid"
  cellpadding=3
  AutoGenerateColumns="False"
  DataKeyField="ProductID"
  OnEditCommand="editProduct"
  OnCancelCommand="cancelEdit"
  OnUpdateCommand="updateProduct"
  Runat="Server">
  <Columns>
    <asp:EditCommandColumn
      EditText="Edit"
      CancelText="Cancel"
      UpdateText="Update" />
    <asp:TemplateColumn>
      <ItemTemplate>
       <%# DataBinder.Eval( Container.DataItem, "ProductID" )%>
      </ItemTemplate>
    </asp:TemplateColumn>
    <asp:TemplateColumn>
      <ItemTemplate>
       <%# DataBinder.Eval( Container.DataItem, "ProductName" )%>
      </ItemTemplate>
      <EditItemTemplate>
       <asp:TextBox
        id="ProductName"
        Text='<%# DataBinder.Eval( Container.DataItem, "ProductName" )%>'
        Runat="Server"/>
       <asp:RequiredFieldValidator
         ControlToValidate="ProductName"
         Display="Dynamic"
         Runat="Server">
        You must enter a product name!
       </asp:RequiredFieldValidator>
      </EditItemTemplate>
    </asp:TemplateColumn>
    <asp:TemplateColumn>
      <ItemTemplate>
       <%# DataBinder.Eval( Container.DataItem, "UnitPrice", "{0:c}" ) %>
      </ItemTemplate>
      <EditItemTemplate>
       <asp:TextBox
        id="UnitPrice"
        Text='<%# DataBinder.Eval( Container.DataItem, "UnitPrice" )%>'
        Runat="Server"/>
       <asp:RequiredFieldValidator
         ControlToValidate="UnitPrice"
         Display="Dynamic"
         Runat="Server">
        You must enter a unit price!
       </asp:RequiredFieldValidator>
       <asp:CompareValidator
         ControlToValidate="UnitPrice"
         Display="Dynamic"
         Type="Currency"
         Operator="DataTypeCheck"
         Runat="Server">
        The unit price must be a money amount!
       </asp:CompareValidator>
      </EditItemTemplate>
    </asp:TemplateColumn>
  </Columns>
</asp:DataGrid>

</form>

</body>
</html>
