<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">
  const int PageSize = 10;
  SqlConnection myConnection;
  SqlDataAdapter myAdapter;
  String sqlString;
  DataSet myDataSet;

  void Page_Load( Object s, EventArgs e )
  {
    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" );
    if (!IsPostBack) 
    {
      ViewState[ "PageNumber" ] = 0;
      ViewState[ "PageCount" ] = getPageCount();
      ViewState[ "startProductID" ] = -1;
      ViewState[ "endProductID" ] = -1;
      moveNext();
    }
  }

  void Page_PreRender( Object s, EventArgs e )
  {
    if ( (int)ViewState[ "PageNumber" ] == (int)ViewState[ "PageCount" ] )
      nextButton.Enabled = false;
    else
      nextButton.Enabled = true;
    if ( (int)ViewState[ "PageNumber" ] == 1 )
      prevButton.Enabled = false;
    else
      prevButton.Enabled = true;
  }

  int getPageCount()
  {
    sqlString = "Select Count(*) theCount From Products";
    SqlCommand myCommand = new SqlCommand( sqlString, myConnection );
    myConnection.Open();
    double theCount = (int)myCommand.ExecuteScalar();
    myConnection.Close();
    return (int)Math.Ceiling( theCount / PageSize );
  }

  void pageGrid( Object s, EventArgs e )
  {
    if ( ( ( LinkButton ) s).CommandArgument == "Next" )
      moveNext();
    else
      movePrevious();
  }

  void moveNext()
  {
    sqlString = "Select Top " + PageSize.ToString() + " * from Products Where ProductID > " + ViewState[ "endProductID" ].ToString();
    myAdapter = new SqlDataAdapter( sqlString, myConnection );
    myDataSet = new DataSet();
    myAdapter.Fill( myDataSet, "Products" );
    myDataGrid.DataSource = myDataSet;
    myDataGrid.DataBind();
    ViewState[ "PageNumber" ] = (int)ViewState[ "PageNumber" ] + 1;
    ViewState[ "startProductID" ] = myDataSet.Tables[ "Products" ].Rows[ 0 ][ "ProductID", DataRowVersion.Current ];
    int lastRowIndex = myDataSet.Tables[ "Products" ].Rows.Count - 1;
    ViewState[ "endProductID" ] = myDataSet.Tables[ "Products" ].Rows[ lastRowIndex ][ "ProductID", DataRowVersion.Current ];
  }

  void movePrevious()
  {
    sqlString = "Select Top " + PageSize.ToString() + " * from Products Where ProductID < " + ViewState[ "startProductID" ].ToString() + " Order By ProductID DESC";
    myAdapter = new SqlDataAdapter( sqlString, myConnection );
    myDataSet = new DataSet();
    myAdapter.Fill( myDataSet, "Products" );
    DataView myDataView = myDataSet.Tables[ "Products" ].DefaultView;
    myDataView.Sort = "ProductID";
    myDataGrid.DataSource = myDataView;
    myDataGrid.DataBind();
    int lastRowIndex = myDataSet.Tables[ "Products" ].Rows.Count - 1;
    ViewState[ "PageNumber" ] = (int)ViewState[ "PageNumber" ] - 1;
    ViewState[ "startProductID" ] = myDataSet.Tables[ "Products" ].Rows[ lastRowIndex ][ "ProductID", DataRowVersion.Current  ];
    ViewState[ "endProductID" ] = myDataSet.Tables[ "Products" ].Rows[ 0 ][ "ProductID", DataRowVersion.Current ];
  }
</Script>

<html>
<head><title>DataGrid</title></head>
<body>

Page <%=ViewState[ "PageNumber" ] %> of <%=ViewState[ "PageCount" ] %>

<form Runat="Server">

<asp:DataGrid
  id="myDataGrid"
  AutoGenerateColumns="False"
  cellpadding=3
  Runat="Server">
  <Columns>
    <asp:BoundColumn HeaderText="Product ID" DataField="ProductID"/>
    <asp:BoundColumn HeaderText="Product Name" DataField="ProductName"/>
    <asp:BoundColumn HeaderText="Price" DataField="UnitPrice" DataFormatString="{0:c}"/>
  </Columns>
</asp:DataGrid>
<p>
<asp:LinkButton
  id="prevButton"
  Text="<< Previous"
  onClick="pageGrid"
  commandArgument="Previous"
  Runat="Server"/>

<asp:LinkButton
  id="nextButton"
  Text="Next >>"
  onClick="pageGrid"
  commandArgument="Next"
  Runat="Server"/>

</form>

</body>
</html>
