<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">
  void Page_Load( Object s, EventArgs e )
  {
    if ( !IsPostBack )
      BindData();
  }

  void BindData()
  {
    SqlConnection myConnection;
    SqlCommand myCommand;
    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Pubs" );
    myCommand = new SqlCommand( "Select au_id, au_lname, au_fname, phone from Authors order by au_lname", myConnection );
    myConnection.Open();
    myDataList.DataSource = myCommand.ExecuteReader();
    myDataList.DataBind();
    myConnection.Close();
  }

  void editAuthor( Object s, DataListCommandEventArgs e )
  {
    myDataList.EditItemIndex = e.Item.ItemIndex;
    BindData();
  }

  void cancelEdit( Object s, DataListCommandEventArgs e )
  {
    myDataList.EditItemIndex = -1;
    BindData();
  }

  void deleteAuthor( Object s, DataListCommandEventArgs e )
  {
    SqlConnection myConnection;
    SqlCommand myCommand;
    String sqlString;
    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Pubs" );
    sqlString = "Delete Authors Where au_id=@authorID";
    myCommand = new SqlCommand( sqlString, myConnection );
    myCommand.Parameters.Add( new SqlParameter( "@authorID", SqlDbType.VarChar, 11 ) );
    myCommand.Parameters[ "@authorID" ].Value = myDataList.DataKeys[ e.Item.ItemIndex ];
    myConnection.Open();
    myCommand.ExecuteNonQuery();
    myDataList.DataBind();
    myConnection.Close();
    myDataList.EditItemIndex = -1;
    BindData();
  }

  void updateAuthor( Object s, DataListCommandEventArgs e )
  {
    SqlConnection myConnection;
    SqlCommand myCommand;
    String sqlString;
    myConnection = new SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Pubs" );
    sqlString = "Update Authors Set au_lname=@lastname, au_fname=@firstname, phone=@phone Where au_id=@authorID";
    myCommand = new SqlCommand( sqlString, myConnection );
    myCommand.Parameters.Add( new SqlParameter( "@lastname", SqlDbType.VarChar, 40 ) );
    myCommand.Parameters[ "@lastname" ].Value = ( (TextBox) e.Item.FindControl( "lastname" ) ).Text;
    myCommand.Parameters.Add( new SqlParameter( "@firstname", SqlDbType.VarChar, 20 ) );
    myCommand.Parameters[ "@firstname" ].Value = ( (TextBox) e.Item.FindControl( "firstname" ) ).Text;
    myCommand.Parameters.Add( new SqlParameter( "@phone", SqlDbType.Char, 12 ) );
    myCommand.Parameters[ "@phone" ].Value = ( (TextBox) e.Item.FindControl( "phone" ) ).Text;
    myCommand.Parameters.Add( new SqlParameter( "@authorID", SqlDbType.VarChar, 11 ) );
    myCommand.Parameters[ "@authorID" ].Value = myDataList.DataKeys[ e.Item.ItemIndex ];
    myConnection.Open();
    myCommand.ExecuteNonQuery();
    myDataList.DataBind();
    myConnection.Close();
    myDataList.EditItemIndex = -1;
    BindData();
  }
</Script>

<html>
<head><title>Edit Authors</title></head>
<body>

<form Runat="Server">

<asp:DataList
  id="myDataList"
  cellpadding=10
  cellspacing=0
  gridlines="both"
  RepeatColumns="3"
  RepeatDirection="Horizontal"
  DataKeyField="au_id"
  OnEditCommand="editAuthor"
  OnDeleteCommand="deleteAuthor"
  OnUpdateCommand="updateAuthor"
  OnCancelCommand="cancelEdit"
  Runat="Server">

  <ItemTemplate>
    <asp:LinkButton
      Text="Edit"
      CommandName="edit"
      Runat="Server"/>
    <%# DataBinder.Eval( Container.DataItem, "au_lname" )%>
  </ItemTemplate>

  <EditItemTemplate>
     <b>Last Name:</b>
     <br><asp:TextBox
       id="lastname"
       text='<%# DataBinder.Eval( Container.DataItem, "au_lname" ) %>'
       Runat="Server"/>
     <p>
     <b>First Name:</b>
     <br><asp:TextBox
       id="firstname"
       text='<%# DataBinder.Eval( Container.DataItem, "au_fname" ) %>'
       Runat="Server"/>
     <p>
     <b>Phone:</b>
     <br><asp:TextBox
       id="phone"
       text='<%# DataBinder.Eval( Container.DataItem, "phone" ) %>'
       Runat="Server"/>
     <p>
     <asp:Button
       Text="Update"
       CommandName="update"
       Runat="Server"/>
     <asp:Button
       Text="Delete"
       CommandName="delete"
       Runat="Server"/>
     <asp:Button
       Text="Cancel"
       CommandName="cancel"
       Runat="Server"/>
  </EditItemTemplate>

</asp:DataList>

</form>

</body>
</html>
