<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">
  Sub Page_Load( s As Object, e As EventArgs )
    If Not isPostBack Then
      BindData
    End If
  End Sub

  Sub BindData
    Dim myConnection As SQLConnection
    Dim myCommand As SQLCommand
    myConnection = New SQLConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" )
    myCommand = New SQLCommand( _ 
      "Select * from Products", myConnection )
    myConnection.Open()
    myDataGrid.DataSource = myCommand.ExecuteReader()
    myDataGrid.DataBind()
    myConnection.Close()
  End Sub

  Sub editProduct( s As Object, e As DataGridCommandEventArgs )
    myDataGrid.EditItemIndex = e.Item.ItemIndex
    BindData
  End Sub

  Sub cancelEdit( s As Object, e As DataGridCommandEventArgs )
    myDataGrid.EditItemIndex = -1
    BindData
  End Sub

  Sub updateProduct( s As Object, e As DataGridCommandEventArgs )

    ' Get New Values
    Dim productName As TextBox
    productName = e.Item.Cells( 2 ).Controls( 0 )
    Dim unitPrice As TextBox
    unitPrice = e.Item.Cells( 3 ).Controls( 0 )

    ' Update Database
    Dim myConnection As SqlConnection
    Dim myCommand As SqlCommand
    Dim sqlString As String

    myConnection = New SqlConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" )
    sqlString = "Update Products Set ProductName = " & _ 
      "@productName, UnitPrice=@unitPrice Where ProductID=@productID"
    myCommand = New SQLCommand( sqlString, myConnection )
    myCommand.Parameters.Add( _
      New SQLParameter( "@ProductName", SqlDbType.NVarChar, 80 ))
    myCommand.Parameters( "@ProductName" ).Value = productName.Text
    myCommand.Parameters.Add( _ 
      New SQLParameter( "@unitprice", SqlDbType.Money ))
    myCommand.Parameters( "@unitPrice" ).Value =  _
      cType( unitPrice.Text, Decimal ) 
    myCommand.Parameters.Add( _ 
      New SQLParameter( "@productID", SqlDbType.INT ))
    myCommand.Parameters( "@productID" ).Value = _
      myDataGrid.DataKeys.Item( e.Item.ItemIndex )
    myConnection.Open()
    myCommand.ExecuteNonQuery
    myConnection.Close()
    myDataGrid.EditItemIndex = -1
    BindData
  End Sub
</Script>

<html>
<head><title>DataGrid</title></head>
<body>

<form Runat="Server">

<asp:DataGrid
  id="myDataGrid"
  cellpadding=3
  AutoGenerateColumns="False"
  DataKeyField="ProductID"
  OnEditCommand="editProduct"
  OnCancelCommand="cancelEdit"
  OnUpdateCommand="updateProduct"
  Runat="Server">
  <Columns>
    <asp:EditCommandColumn
      EditText="Edit"
      CancelText="Cancel"
      UpdateText="Update" />
    <asp:BoundColumn HeaderText="Product ID" 
      DataField="ProductID" ReadOnly="True"/>
    <asp:BoundColumn HeaderText="Product Name" 
      DataField="ProductName" />
    <asp:BoundColumn HeaderText="Price" 
      DataField="UnitPrice" DataFormatString="{0:c}" />
  </Columns>
</asp:DataGrid>

</form>

</body>
</html>
