<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">
  Sub Page_Load( s As Object, e As EventArgs )
    If Not isPostBack Then
      BindData
    End If
  End Sub

  Sub BindData
    Dim myConnection As SQLConnection
    Dim myCommand As SQLCommand
    myConnection = New SQLConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" )
    myCommand = New SQLCommand( "Select * from Products", _
      myConnection )
    myConnection.Open()
    myDataGrid.DataSource = myCommand.ExecuteReader()
    myDataGrid.DataBind()
    myConnection.Close()
  End Sub

  Sub editProduct( s As Object, e As DataGridCommandEventArgs )
    myDataGrid.EditItemIndex = e.Item.ItemIndex
    BindData
  End Sub

  Sub cancelEdit( s As Object, e As DataGridCommandEventArgs )
    myDataGrid.EditItemIndex = -1
    BindData
  End Sub

  Sub updateProduct( s As Object, e As DataGridCommandEventArgs )
    If isValid Then
    ' Get New Values
    Dim productName As TextBox
    productName = e.Item.FindControl( "ProductName" )
    Dim unitPrice As TextBox
    unitPrice = e.Item.FindControl( "UnitPrice" )

    ' Update Database
    Dim myConnection As SQLConnection
    Dim myCommand As SQLCommand
    Dim sqlString As String

    myConnection = New SQLConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" )
    sqlString = "Update Products Set ProductName=@productName, " & _
      "UnitPrice=@unitPrice Where ProductID=@productID"
    myCommand = New SQLCommand( sqlString, myConnection )
    myCommand.Parameters.Add( _ 
      New SQLParameter( "@ProductName", SqlDbType.NVarChar, 80 ))
    myCommand.Parameters( "@ProductName" ).Value = _ 
      productName.Text
    myCommand.Parameters.Add( _ 
      New SQLParameter( "@unitprice", SqlDbType.Money ))
    myCommand.Parameters( "@unitPrice" ).Value = _ 
      CType( unitPrice.Text, Decimal )
    myCommand.Parameters.Add( _
      New SQLParameter( "@productID", SqlDbType.INT ))
    myCommand.Parameters( "@productID" ).Value = _ 
      myDataGrid.DataKeys.Item( e.Item.ItemIndex )
    myConnection.Open()
    myCommand.ExecuteNonQuery
    myConnection.Close()
    myDataGrid.EditItemIndex = -1
    BindData
    End If
  End Sub
</Script>

<html>
<head><title>DataGrid</title></head>
<body>

<form Runat="Server">

<asp:DataGrid
  id="myDataGrid"
  cellpadding=3
  AutoGenerateColumns="False"
  DataKeyField="ProductID"
  OnEditCommand="editProduct"
  OnCancelCommand="cancelEdit"
  OnUpdateCommand="updateProduct"
  Runat="Server">
  <Columns>
    <asp:EditCommandColumn
      EditText="Edit"
      CancelText="Cancel"
      UpdateText="Update" />
    <asp:TemplateColumn>
      <ItemTemplate>
       <%# Container.DataItem( "ProductID" )%>
      </ItemTemplate>
    </asp:TemplateColumn>
    <asp:TemplateColumn>
      <ItemTemplate>
       <%# Container.DataItem( "ProductName" )%>
      </ItemTemplate>
      <EditItemTemplate>
       <asp:TextBox
        id="ProductName"
        Text='<%# Container.DataItem( "ProductName" )%>'
        Runat="Server"/>
       <asp:RequiredFieldValidator
         ControlToValidate="ProductName"
         Display="Dynamic"
         Runat="Server">
        You must enter a product name!
       </asp:RequiredFieldValidator>
      </EditItemTemplate>
    </asp:TemplateColumn>
    <asp:TemplateColumn>
      <ItemTemplate>
       <%# String.Format( "{0:c}", Container.DataItem( "UnitPrice" ) ) %>
      </ItemTemplate>
      <EditItemTemplate>
       <asp:TextBox
        id="UnitPrice"
        Text='<%# Container.DataItem( "UnitPrice" )%>'
        Runat="Server"/>
       <asp:RequiredFieldValidator
         ControlToValidate="UnitPrice"
         Display="Dynamic"
         Runat="Server">
        You must enter a unit price!
       </asp:RequiredFieldValidator>
       <asp:CompareValidator
         ControlToValidate="UnitPrice"
         Display="Dynamic"
         Type="Currency"
         Operator="DataTypeCheck"
         Runat="Server">
        The unit price must be a money amount!
       </asp:CompareValidator>
      </EditItemTemplate>
    </asp:TemplateColumn>
  </Columns>
</asp:DataGrid>

</form>

</body>
</html>
