<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">
  Const PageSize = 10
  Dim myConnection As SqlConnection
  Dim myAdapter As SqlDataAdapter
  Dim sqlString As String
  Dim myDataSet As DataSet

  Sub Page_Load( s As Object, e As EventArgs )
    myConnection = New SQLConnection( "Server=Localhost;uid=sa;pwd=secret;Database=Northwind" )
    If Not isPostBack Then
      ViewState( "PageNumber" ) = 0
      ViewState( "PageCount" ) = getPageCount()
      ViewState( "startProductID" ) = -1
      ViewState( "endProductID" ) = -1
      moveNext
    End If
  End Sub

  Sub Page_PreRender( s As Object, e As EventArgs )
    If ViewState( "PageNumber" ) = ViewState( "PageCount" ) Then
      nextButton.Enabled = False
    Else
      nextButton.Enabled = True
    End If
    If ViewState( "PageNumber" ) = 1 Then
      prevButton.Enabled = False
    Else
      prevButton.Enabled = True
    End If
  End Sub

  Function getPageCount As Integer
    Dim theCount As Double
    Dim sqlString As String
    Dim myCommand As SQLCommand
    sqlString = "Select Count(*) theCount From Products"
    myCommand = New SQLCommand( sqlString, myConnection )
    myConnection.Open()
    theCount = myCommand.ExecuteScalar()
    myConnection.Close()
    Return Math.Ceiling( theCount / PageSize )
  End Function

  Sub pageGrid( s As Object, e As EventArgs )
    If s.CommandArgument = "Next" Then
      moveNext
    Else
      movePrevious
    End If
  End Sub

  Sub moveNext
    Dim lastRowIndex As Integer
    sqlString = "Select Top " & PageSize.toString() & " * from Products " _
      & "Where ProductID > " & ViewState( "endProductID" ).toString()
    myAdapter = New SQLDataAdapter( sqlString, myConnection )
    myDataSet = New DataSet
    myAdapter.Fill( myDataSet, "Products" )
    myDataGrid.DataSource = myDataSet
    myDataGrid.DataBind()
    ViewState( "PageNumber" ) = ViewState( "PageNumber" ) + 1
    ViewState( "startProductID" ) = MyDataSet.Tables( "Products" ).Rows( 0 ).Item( "ProductID", DataRowVersion.Current )
    lastRowIndex = myDataSet.Tables( "Products" ).Rows.Count - 1
    ViewState( "endProductID" ) = MyDataSet.Tables( "Products" ).Rows( lastRowIndex ).Item( "ProductID", DataRowVersion.Current )
  End Sub

  Sub movePrevious
    Dim myDataView As DataView
    Dim lastRowIndex As Integer
    sqlString = "Select Top " & PageSize.toString() & " * from Products " _
      & " Where ProductID < " & ViewState( "startProductID" ).toString() _
      & " Order By ProductID DESC"
    myAdapter = New SQLDataAdapter( sqlString, myConnection )
    myDataSet = New DataSet
    myAdapter.Fill( myDataSet, "Products" )
    myDataView = myDataSet.Tables( "Products" ).DefaultView
    myDataView.Sort = "ProductID"
    myDataGrid.DataSource = myDataView
    myDataGrid.DataBind()
    lastRowIndex = myDataSet.Tables( "Products" ).Rows.Count - 1
    ViewState( "PageNumber" ) = ViewState( "PageNumber" ) - 1
    ViewState( "startProductID" ) = MyDataSet.Tables( "Products" ).Rows( lastRowIndex ).Item( "ProductID", DataRowVersion.Current  )
    ViewState( "endProductID" ) = MyDataSet.Tables( "Products" ).Rows( 0 ).Item( "ProductID", DataRowVersion.Current )
  End Sub
</Script>

<html>
<head><title>DataGrid</title></head>
<body>

Page <%=ViewState( "PageNumber" ) %> of <%=ViewState( "PageCount" ) %>

<form Runat="Server">

<asp:DataGrid
  id="myDataGrid"
  AutoGenerateColumns="False"
  cellpadding=3
  Runat="Server">
  <Columns>
    <asp:BoundColumn HeaderText="Product ID" DataField="ProductID"/>
    <asp:BoundColumn HeaderText="Product Name" DataField="ProductName"/>
    <asp:BoundColumn HeaderText="Price" DataField="UnitPrice" DataFormatString="{0:c}"/>
  </Columns>
</asp:DataGrid>
<p>
<asp:LinkButton
  id="prevButton"
  Text="<< Previous"
  onClick="pageGrid"
  commandArgument="Previous"
  Runat="Server"/>

<asp:LinkButton
  id="nextButton"
  Text="Next >>"
  onClick="pageGrid"
  commandArgument="Next"
  Runat="Server"/>

</form>

</body>
</html>
