<script language="vb" runat="server">

  Sub Page_Load(sender as Object, e as EventArgs)
    ' Create two ArrayLists, aTerritories and aStates
    Dim aTerritories as New ArrayList
    Dim aStates as New ArrayList

    ' Use the Add method to add the 50 states of the US
    aStates.Add("Alabama")
    aStates.Add("Alaska")
    aStates.Add("Arkansas")
    ' ...
    aStates.Add("Wyoming")

    ' Build up our list of territories, which includes
    ' all 50 states plus some additional countries
    aTerritories.AddRange(aStates)  ' add all 50 states
    aTerritories.Add("Guam")
    aTerritories.Add("Puerto Rico")

    ' We'd like the first territory to be the District of Columbia,
    ' so we'll explicitly add it to the beginning of the ArrayList
    aTerritories.Insert(0, "District of Columbia")

    ' Display all of the territories with a for loop
    lblTerritories.Text = "<i>There are " & aTerritories.Count & _
                          "territories...</i><br>"

    Dim i as Integer
    For i = 0 to aTerritories.Count - 1
      lblTerritories.Text = lblTerritories.Text & aTerritories(i) & "<br>"
    Next

    ' We can remove objects in one of four ways:
    '  ... We can remove a specific item
    aTerritories.Remove("Wyoming")

    ' ... We can remove an element at a specific position
    aTerritories.RemoveAt(0)  ' will get rid of District 
                              ' of Columbia,
                              ' the first element

    ' Display all of the territories with foreach loop
    lblFewerTerritories.Text = "<i>There are now " & _
                aTerritories.Count & " territories...</i><br>"

    Dim s as String
    For Each s in aTerritories
      lblFewerTerritories.Text = lblFewerTerritories.Text & _
                                 s & "<br>"
    Next

    ' ... we can remove a chunk of elements from the
    '     array with RemoveRange
    aTerritories.RemoveRange(0, 2) ' will get rid of the 
                                   ' first two elements

    ' Display all of the territories with foreach loop
    lblEvenFewerTerritories.Text = "<i>There are now " & _
              aTerritories.Count & " territories...</i><br>"

    For Each s in aTerritories
      lblEvenFewerTerritories.Text = lblEvenFewerTerritories.Text & _
                                     s & "<br>"
    Next

    ' Finally, we can clear the ENTIRE array using the clear method
    aTerritories.Clear()
  End Sub

 </script>

 <html>
 <body>
   <b>The Territories of the United States:</b><br>  
   <asp:label id="lblTerritories" runat="server" />

   <p>

   <b>After some working with the Territories ArrayList:</b><br>
   <asp:label id="lblFewerTerritories" runat="server" />

   <p>

   <b>After further working with the Territories ArrayList:</b><br>
   <asp:label id="lblEvenFewerTerritories" runat="server" />
 </body>
 </html>
