<script language="c#" runat="server">

  void Page_Load(Object sender, EventArgs e)
  {
    // Create two ArrayLists, aTerritories and aStates
    ArrayList aTerritories = new ArrayList();
    ArrayList aStates = new ArrayList();

    // Use the Add method to add the 50 states of the US
    aStates.Add("Alabama");
    aStates.Add("Alaska");
    aStates.Add("Arkansas");
    // ...
    aStates.Add("Wyoming");

    // Build up our list of territories, which includes
    // all 50 states plus some additional countries
    aTerritories.AddRange(aStates);  // add all 50 states
    aTerritories.Add("Guam");
    aTerritories.Add("Puerto Rico");

    // We'd like the first territory to be the District of Columbia,
    // so we'll explicitly add it to the beginning of the ArrayList
    aTerritories.Insert(0, "District of Columbia");

    // Display all of the territories with a for loop
    lblTerritories.Text = "<i>There are " + aTerritories.Count +
                          "territories...</i><br>";
    for (int i=0; i < aTerritories.Count; i++)
      lblTerritories.Text += aTerritories[i] + "<br>";


    // We can remove objects in one of four ways:
    //  ... We can remove a specific item
    aTerritories.Remove("Wyoming");

    // ... We can remove an element at a specific position
    aTerritories.RemoveAt(0);  // will get rid of District 
                               // of Columbia,
                               // the first element

    // Display all of the territories with foreach loop
    lblFewerTerritories.Text = "<i>There are now " + 
                aTerritories.Count + " territories...</i><br>";
    foreach (String s in aTerritories)
      lblFewerTerritories.Text += s + "<br>";

    // ... we can remove a chunk of elements from the
    //     array with RemoveRange
    aTerritories.RemoveRange(0, 2);  // will get rid of the 
                                     // first two elements

    // Display all of the territories with foreach loop
    lblEvenFewerTerritories.Text = "<i>There are now " + 
              aTerritories.Count + " territories...</i><br>";
    foreach (String s in aTerritories)
      lblEvenFewerTerritories.Text += s + "<br>";

    // Finally, we can clear the ENTIRE array using the clear method
    aTerritories.Clear();
  }

 </script>

 <html>
 <body>
   <b>The Territories of the United States:</b><br>  
   <asp:label id="lblTerritories" runat="server" />

   <p>

   <b>After some working with the Territories ArrayList:</b><br>
   <asp:label id="lblFewerTerritories" runat="server" />

   <p>

   <b>After further working with the Territories ArrayList:</b><br>
   <asp:label id="lblEvenFewerTerritories" runat="server" />
 </body>
 </html>
