<%@ Page Debug=True %>
<%@ Import Namespace="System.Diagnostics" %>
<script language="VB" runat="server">
  Sub Page_Load(sender as Object, e as EventArgs)
    If Not Page.IsPostBack then
      Dim objPerfCounterCat as PerformanceCounterCategory

      For Each objPerfCounterCat in PerformanceCounterCategory.GetCategories()
        lstCategories.Items.Add(New ListItem(objPerfCounterCat.CategoryName))
      Next

      'Add the counters for the first category
      PopulateCounters(PerformanceCounterCategory.GetCategories()(0))
    End If
  End Sub


  Sub PopulateCounters(objPerfCat as PerformanceCounterCategory)
    'Populates the lstCounters list box with the counters for the selected
    'performance category (objPerfCat)...

    lstCounters.Items.Clear()

    PopulateInstances(objPerfCat)

    Dim objCounter as PerformanceCounter
    If lstInstances.Items.Count > 0 then
      For Each objCounter in objPerfCat.GetCounters(lstInstances.Items(0).Value)
        lstCounters.Items.Add(New ListItem(objCounter.CounterName))
      Next
      DisplayCounter(objPerfCat.GetCounters(lstInstances.Items(0).Value)(0))
    Else
      For Each objCounter in objPerfCat.GetCounters()
        lstCounters.Items.Add(New ListItem(objCounter.CounterName))
      Next
      DisplayCounter(objPerfCat.GetCounters()(0))
    End If


  End Sub


  Sub PopulateInstances(objPerfCat as PerformanceCounterCategory)
    'Populates the lstInstances list box with the counters for the selected
    'performance category (objPerfCat)...

    lstInstances.Items.Clear()

    Dim strInstanceName as String
    For Each strInstanceName in objPerfCat.GetInstanceNames()
      lstInstances.Items.Add(New ListItem(strInstanceName))
    Next
  End Sub


  Sub lstCategories_OnChange(sender as Object, e as EventArgs)
    Dim objPerfCat as PerformanceCounterCategory
    objPerfCat = New PerformanceCounterCategory(lstCategories.SelectedItem.Value)

    PopulateCounters(objPerfCat)
  End Sub


  Sub lstCounters_OnChange(sender as Object, e as EventArgs)
    'Display counter information for the selected counter and category
    If Not lstCounters.SelectedItem Is Nothing then
      Dim objPerf as New PerformanceCounter()
      objPerf.CategoryName = lstCategories.SelectedItem.Value
      objPerf.CounterName = lstCounters.SelectedItem.Value
      If Not lstInstances.SelectedItem Is Nothing then
        objPerf.InstanceName = lstInstances.SelectedItem.Value
      End If

      DisplayCounter(objPerf)
    End If
  End Sub


  Sub lstInstances_OnChange(sender as Object, e as EventArgs)
    'Display counter information for the selected counter and category
    If Not lstCounters.SelectedItem Is Nothing then
      Dim objPerf as New PerformanceCounter()
      objPerf.CategoryName = lstCategories.SelectedItem.Value
      objPerf.CounterName = lstCounters.SelectedItem.Value
      If Not lstInstances.SelectedItem Is Nothing then
        objPerf.InstanceName = lstInstances.SelectedItem.Value
      End If


      DisplayCounter(objPerf)
    End If
  End Sub


  Sub DisplayCounter(objPerf as PerformanceCounter)
    try
      objPerf.NextValue()
      lblLastValue.Text = objPerf.NextValue()
    catch e as Exception
      try
        Dim tmpCat = New PerformanceCounterCategory(lstCategories.SelectedItem.Value)
        objPerf.InstanceName = tmpCat.GetInstanceNames()(0)
        objPerf.NextValue()
        lblLastValue.Text = objPerf.NextValue()
      catch e2 as Exception
        lblLastValue.Text = "<font color=red>ERROR: " & e.Message & "</font>"        
      end try
    end try
  End Sub
</script>

<html>
<body>
  <form runat="server">
    <h1>Performance Counter Display</h1>
    <asp:listbox runat="server" id="lstCategories" Rows="1" AutoPostBack="True"
                 OnSelectedIndexChanged="lstCategories_OnChange" />
    <asp:listbox runat="server" id="lstCounters" Rows="1" AutoPostBack="True"
                 OnSelectedIndexChanged="lstCounters_OnChange" />
    <asp:listbox runat="server" id="lstInstances" Rows="1" AutoPostBack="True"
                 OnSelectedIndexChanged="lstInstances_OnChange" />
    <p>
    <b>Current Value:</b>
    <asp:label id="lblLastValue" runat="server" />
  </form>
</body>
</html>