<%@ Page Debug=true %>
<%@ Import Namespace="System.Diagnostics" %>
<script language="c#" runat="server">
  void Page_Load(Object sender, EventArgs e)
  {
    if (!Page.IsPostBack)
    {
      foreach (PerformanceCounterCategory objPerfCounterCat in PerformanceCounterCategory.GetCategories())
        lstCategories.Items.Add(new ListItem(objPerfCounterCat.CategoryName));

      //Add the counters for the first category
      PopulateCounters(PerformanceCounterCategory.GetCategories()[0]);
    }
  }


  void PopulateCounters(PerformanceCounterCategory objPerfCat)
  {
    // Populates the lstCounters list box with the counters for the selected
    // performance category (objPerfCat)...

    lstCounters.Items.Clear();

    PopulateInstances(objPerfCat);

    if (lstInstances.Items.Count > 0)
    {
      foreach (PerformanceCounter objCounter in objPerfCat.GetCounters(lstInstances.Items[0].Value))
        lstCounters.Items.Add(new ListItem(objCounter.CounterName));

      DisplayCounter(objPerfCat.GetCounters(lstInstances.Items[0].Value)[0]);
    } else {

      foreach (PerformanceCounter objCounter in objPerfCat.GetCounters())
        lstCounters.Items.Add(new ListItem(objCounter.CounterName));

      DisplayCounter(objPerfCat.GetCounters()[0]);
    }
  }


  void PopulateInstances(PerformanceCounterCategory objPerfCat)
  {
    // Populates the lstInstances list box with the counters for the selected
    // performance category (objPerfCat)...

    lstInstances.Items.Clear();

    foreach (String strInstanceName in objPerfCat.GetInstanceNames())
      lstInstances.Items.Add(new ListItem(strInstanceName));
  }



  void lstCategories_OnChange(Object sender, EventArgs e)
  {
    PerformanceCounterCategory objPerfCat;
    objPerfCat = new PerformanceCounterCategory(lstCategories.SelectedItem.Value);

    PopulateCounters(objPerfCat);
  }


  void lstCounters_OnChange(Object sender, EventArgs e)
  {
    // Display counter information for the selected counter and category
    if (lstCounters.SelectedItem != null)
    {
      PerformanceCounter objPerf = new PerformanceCounter();
      objPerf.CategoryName = lstCategories.SelectedItem.Value;
      objPerf.CounterName = lstCounters.SelectedItem.Value;
      if (lstInstances.SelectedItem != null) objPerf.InstanceName = lstInstances.SelectedItem.Value;

      DisplayCounter(objPerf);
    }
  }


  void lstInstances_OnChange(Object sender,  EventArgs e)
  {
    // Display counter information for the selected counter and category
    if (lstCounters.SelectedItem != null)
    {
      PerformanceCounter objPerf = new PerformanceCounter();
      objPerf.CategoryName = lstCategories.SelectedItem.Value;
      objPerf.CounterName = lstCounters.SelectedItem.Value;
      if (lstInstances.SelectedItem != null) objPerf.InstanceName = lstInstances.SelectedItem.Value;

      DisplayCounter(objPerf);
    }
  }

  void DisplayCounter(PerformanceCounter objPerf)
  {
    try {
      objPerf.NextValue();
      lblLastValue.Text = objPerf.NextValue().ToString();
    }
    catch (Exception e)
    {
      try {
        PerformanceCounterCategory tmpCat = new PerformanceCounterCategory(lstCategories.SelectedItem.Value);
        objPerf.InstanceName = tmpCat.GetInstanceNames()[0];
        objPerf.NextValue();
        lblLastValue.Text = objPerf.NextValue().ToString();
      }
      catch (Exception e2)
      {
        lblLastValue.Text = "<font color=red>ERROR: " + e.Message + "</font>";
      }
    }
  }
</script>

<html>
<body>
  <form runat="server">
    <h1>Performance Counter Display</h1>
    <asp:listbox runat="server" id="lstCategories" Rows="1" AutoPostBack="True"
                 OnSelectedIndexChanged="lstCategories_OnChange" />
    <asp:listbox runat="server" id="lstCounters" Rows="1" AutoPostBack="True"
                 OnSelectedIndexChanged="lstCounters_OnChange" />
    <asp:listbox runat="server" id="lstInstances" Rows="1" AutoPostBack="True"
                 OnSelectedIndexChanged="lstInstances_OnChange" />
    <p>
    <b>Current Value:</b>
    <asp:label id="lblLastValue" runat="server" />
  </form>
</body>
</html>