<%@ Import Namespace="System.IO" %>
<script language="c#" runat="server">

  void Page_Load(Object sender, EventArgs e)
  {

    if (!Page.IsPostBack)
    {
      lblDirInfo.Text = "Enter the fully qualified name of the " +
                         "directory that you're interested in (<i>i.e., C:\\</i>)";
    } else { 

      // a postback, so get the directory information
      DirectoryInfo dirInfo = new DirectoryInfo(txtDirectoryName.Text);
      try {
        // Display the directory properties
        lblDirInfo.Text = "<b>Information for " + txtDirectoryName.Text + "</b><br>" +
                   "Attributes: " + DisplayAttributes(dirInfo.Attributes) + "<br>" +
                   "Creation Time: " + dirInfo.CreationTime.ToShortDateString() + ", " +
                                       dirInfo.CreationTime.ToLongTimeString() + "<br>" +
                   "Full Name: " + dirInfo.FullName + "<br>" +
                   "Root Drive: " + dirInfo.Root + "<br>" +
                   "Parent Directory Name: " + dirInfo.Parent + "<br>" +
                   "Directory Name: " + dirInfo.Name + "<br>" +
                   "Last Access Time: " + dirInfo.LastAccessTime.ToShortDateString() + ", " + 
                                        dirInfo.LastAccessTime.ToLongTimeString() + "<br>" +
                   "Last Write Time: " + dirInfo.LastWriteTime.ToShortDateString() + ", " + 
                                        dirInfo.LastWriteTime.ToLongTimeString() + "<br>";

        // List all of the subdirectories for the current directory:
        lblSubDirectories.Text = "<b>Subdirectories of " + dirInfo.FullName + "</b><br>";
        foreach (DirectoryInfo dirSubDirectory in dirInfo.GetDirectories())
          lblSubDirectories.Text += dirSubDirectory.FullName + "<br>";



      } catch (DirectoryNotFoundException dnfException) {
        // Whoops!  A directoryNotFound Exception has been raised!
        // The user entered an invalid directory name!
        lblDirInfo.Text = "<font color=red><b>" + dnfException.Message + "</b></font>";
      }
    }
  }


  String DisplayAttributes(FileAttributes fsa)
  {
    String strOutput = "";
    if ((fsa & FileAttributes.Archive) > 0) strOutput += "Archived, ";
    if ((fsa & FileAttributes.Compressed) > 0) strOutput += "Compressed, ";
    if ((fsa & FileAttributes.Directory) > 0) strOutput += "Directory, ";
    if ((fsa & FileAttributes.Encrypted) > 0) strOutput += "Encrypted, ";
    if ((fsa & FileAttributes.Hidden) > 0) strOutput += "Hidden, ";
    if ((fsa & FileAttributes.Normal) > 0) strOutput += "Normal, ";
    if ((fsa & FileAttributes.NotContentIndexed) > 0) strOutput += "Not Content Indexed, ";
    if ((fsa & FileAttributes.Offline) > 0) strOutput += "Offline, ";
    if ((fsa & FileAttributes.ReadOnly) > 0) strOutput += "Read Only, ";
    if ((fsa & FileAttributes.ReparsePoint) > 0) strOutput += "Reparse Point, ";
    if ((fsa & FileAttributes.SparseFile) > 0) strOutput += "Sparse File, ";
    if ((fsa & FileAttributes.System) > 0) strOutput += "System, ";
    if ((fsa & FileAttributes.Temporary) > 0) strOutput += "Temporary, ";

    // whack off the trailing ", "
    if (strOutput.Length > 0)
      return strOutput.Substring(0, strOutput.Length - 2);
    else
      return "No attributes found...";
  }

</script>

<html>
<body>
  <form method="post" runat="server">

    <b>Get Information on Directory:</b><br>
    <asp:textbox runat="server" id="txtDirectoryName" />
    <p>
    <asp:button id="btnSubmit" runat="server" type="Submit" text="Go!" />
    <p><hr><p>
    <asp:label runat="server" id="lblDirInfo" />
    <p>
    <asp:label runat="server" id="lblSubDirectories" />
  </form>
</body>
</html>