<%@ Import Namespace="System.IO" %>
<script language="VB" runat="server">

  Sub Page_Load(sender as Object, e as EventArgs)
    If Not Page.IsPostBack then
      lblDirInfo.Text = "Enter the fully qualified name of the " & _
                         "directory that you're interested in (<i>i.e., C:\</i>)"
    Else

      ' a postback, so get the directory information
      Dim dirInfo as DirectoryInfo = new DirectoryInfo(txtDirectoryName.Text)

      Try
        ' Display the directory properties
        lblDirInfo.Text = "<b>Information for " & txtDirectoryName.Text & "</b><br>" & _
                   "Attributes: " & DisplayAttributes(dirInfo.Attributes) & "<br>" & _
                   "Creation Time: " & dirInfo.CreationTime.ToShortDateString() & ", " & _
                                       dirInfo.CreationTime.ToLongTimeString() & "<br>" & _
                   "Full Name: " & dirInfo.FullName & "<br>" & _
                   "Root Drive: " & dirInfo.Root.Name & "<br>" & _
                   "Parent Directory Name: " & dirInfo.Parent.Name & "<br>" & _
                   "Directory Name: " & dirInfo.Name & "<br>" & _
                   "Last Access Time: " & dirInfo.LastAccessTime.ToShortDateString() & ", " & _
                                        dirInfo.LastAccessTime.ToLongTimeString() & "<br>" & _
                   "Last Write Time: " & dirInfo.LastWriteTime.ToShortDateString() & ", " & _
                                        dirInfo.LastWriteTime.ToLongTimeString() & "<br>"


        ' List all of the subdirectories for the current directory:
        lblSubDirectories.Text = "<b>Subdirectories of " & dirInfo.FullName & "</b><br>"
        Dim dirSubDirectory as DirectoryInfo
        For Each dirSubDirectory in dirInfo.GetDirectories()
          lblSubDirectories.Text &= dirSubDirectory.FullName & "<br>"
        Next
      Catch dnfException as DirectoryNotFoundException
        ' Whoops!  A directoryNotFound Exception has been raised!
        ' The user entered an invalid directory name!
        lblDirInfo.Text = "<font color=red><b>" & dnfException.Message & "</b></font>"
      End Try
    End If
  End Sub


  Function DisplayAttributes(fsa as FileAttributes) as String
    Dim strOutput as String = ""

    if ((fsa And FileAttributes.Archive) > 0) Then strOutput &= "Archived, "
    if ((fsa And FileAttributes.Compressed) > 0) Then strOutput &= "Compressed, "
    if ((fsa And FileAttributes.Directory) > 0) Then strOutput &= "Directory, "
    if ((fsa And FileAttributes.Encrypted) > 0) Then strOutput &= "Encrypted, "
    if ((fsa And FileAttributes.Hidden) > 0) Then strOutput &= "Hidden, "
    if ((fsa And FileAttributes.Normal) > 0) Then strOutput &= "Normal, "
    if ((fsa And FileAttributes.NotContentIndexed) > 0) Then strOutput &= "Not Content Indexed, "
    if ((fsa And FileAttributes.Offline) > 0) Then strOutput &= "Offline, "
    if ((fsa And FileAttributes.ReadOnly) > 0) Then strOutput &= "Read Only, "
    if ((fsa And FileAttributes.ReparsePoint) > 0) Then strOutput &= "Reparse Point, "
    if ((fsa And FileAttributes.SparseFile) > 0) Then strOutput &= "Sparse File, "
    if ((fsa And FileAttributes.System) > 0) Then strOutput &= "System, "
    if ((fsa And FileAttributes.Temporary) > 0) Then strOutput &= "Temporary, "

    ' whack off the trailing ", "
    If strOutput.Length > 0 Then
      DisplayAttributes = strOutput.Substring(0, strOutput.Length - 2)
    Else
      DisplayAttributes = "No attributes found..."
    End If
  End Function

</script>

<html>
<body>
  <form method="post" runat="server">

    <b>Get Information on Directory:</b><br>
    <asp:textbox runat="server" id="txtDirectoryName" />
    <p>
    <asp:button id="btnSubmit" runat="server" type="Submit" text="Go!" />
    <p><hr><p>
    <asp:label runat="server" id="lblDirInfo" />
    <p>
    <asp:label runat="server" id="lblSubDirectories" />
  </form>
</body>
</html>