<%@ Import Namespace="System.IO" %>
<script language="C#" runat="server">

  void Page_Load(Object sender, EventArgs e)
  {
    if (!Page.IsPostBack)
    {
      // What directory are we interested in?
      const String strDir = "C:\\My Projects\\ASP.NET Book\\Chapter 2\\Code\\VB";
      lblHeader.Text = "<b><u>File Listing for " + strDir + ":</u></b>";

      // Get the files for the directory strDir
      DirectoryInfo dirInfo = new DirectoryInfo(strDir);
      FileInfo[] aFiles = dirInfo.GetFiles("*.aspx");

      dlFileList.DataSource = aFiles;
      dlFileList.DataBind();
    }
  }


  void dlFileList_Select(Object sender, EventArgs e)
  {
    String strFilePath = dlFileList.DataKeys[dlFileList.SelectedItem.ItemIndex].ToString();

    FileInfo objFile = new FileInfo(strFilePath);

    StreamReader objStream = objFile.OpenText();
    String strContents = objStream.ReadToEnd();
    objStream.Close();

    lblFileContents.Text = "<b>Contents of " + objFile.Name + ":</b>" + 
                           "<xmp>\n" + strContents + "\n</xmp>";
  }

</script>

<html>
<body>

  <form runat="server">

  <asp:label id="lblHeader" runat="server" /><br>
  <asp:DataList runat="server" id="dlFileList"
                OnSelectedIndexChanged="dlFileList_Select"
                DataKeyField="FullName" >
    <ItemTemplate>
      <li><%# DataBinder.Eval(Container.DataItem, "Name") %><br>
      <font size=-1>
        [<asp:linkbutton Text="View Contents" CommandName="Select" runat="server"/>] |
        [<%# DataBinder.Eval(Container.DataItem, "Length") %> bytes]
      </font>
      <p>
    </ItemTemplate>
  </asp:DataList>

  <p><hr><p>
  <asp:label runat="server" id="lblFileContents" />

  </form>
</body>
</html>