<%@ Page Debug=True %>
<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Drawing.Imaging" %>
<script language="VB" runat="server">

  Sub DrawBarGraph(strTitle as String, aX as ArrayList, aY as ArrayList)
    Const iColWidth as Integer = 60, iColSpace as Integer = 25, _
          iMaxHeight as Integer = 400, iHeightSpace as Integer = 25, _
          iXLegendSpace as Integer = 30, iTitleSpace as Integer = 50
    Dim iMaxWidth as Integer = (iColWidth + iColSpace) * aX.Count + iColSpace, _
        iMaxColHeight as Integer = 0, _
        iTotalHeight as Integer = iMaxHeight + iXLegendSpace + iTitleSpace

    Dim objBitmap as Bitmap = new Bitmap(iMaxWidth, iTotalHeight)
    Dim objGraphics as Graphics = Graphics.FromImage(objBitmap)

    objGraphics.FillRectangle(new SolidBrush(Color.White), _
                              0, 0, iMaxWidth, iTotalHeight)
    objGraphics.FillRectangle(new SolidBrush(Color.Ivory), _
                              0, 0, iMaxWidth, iMaxHeight)

    ' find the maximum value
    Dim iValue as Integer    
    For Each iValue in aY
      If iValue > iMaxColHeight then iMaxColHeight = iValue
    Next


    Dim iBarX as Integer = iColSpace, iCurrentHeight as Integer
    Dim objBrush as SolidBrush = new SolidBrush(Color.FromARGB(70,20,20))
    Dim fontLegend as Font = new Font("Arial", 11), _
         fontValues as Font = new Font("Arial", 8), _
         fontTitle as Font = new Font("Arial", 24)

    ' loop through and draw each bar
    Dim iLoop as Integer
    For iLoop = 0 to aX.Count - 1
      iCurrentHeight = (Convert.ToDouble(aY(iLoop)) / Convert.ToDouble(iMaxColHeight)) * Convert.ToDouble(iMaxHeight - iHeightSpace)

      objGraphics.FillRectangle(objBrush, iBarX, iMaxHeight - iCurrentHeight, iColWidth, iCurrentHeight)
      objGraphics.DrawString(aX(iLoop), fontLegend, objBrush, iBarX, iMaxHeight)
      objGraphics.DrawString(String.Format("{0:#,###}", aY(iLoop)), fontValues, objBrush, iBarX, iMaxHeight - iCurrentHeight - 15)

      iBarX += (iColSpace + iColWidth)
    Next

    objGraphics.DrawString(strTitle, fontTitle, objBrush, _
                           (iMaxWidth / 2) - strTitle.Length * 6, iMaxHeight + iXLegendSpace)
    objBitmap.Save("C:\inetpub\wwwroot\graph.gif", ImageFormat.Gif)
 

    objGraphics.Dispose()
    objBitmap.Dispose()
  End Sub


  Sub Page_Load(sender as Object, e as EventArgs)
    Dim aMonths as ArrayList = new ArrayList(), _
        aProfits as ArrayList = new ArrayList()

    aMonths.Add("January")
    aMonths.Add("February")
    aMonths.Add("March")
    aMonths.Add("April")
    aMonths.Add("May")

    aProfits.Add(240500)
    aProfits.Add(220950)
    aProfits.Add(283500)
    aProfits.Add(340000)
    aProfits.Add(325750)

    DrawBarGraph("Profits!", aMonths, aProfits)
  End SUb
</script>