<%@ Import Namespace="System.Drawing" %>
<%@ Import Namespace="System.Drawing.Imaging" %>
<script language="C#" runat="server">

  void DrawBarGraph(String strTitle, ArrayList aX, ArrayList aY)
  {
    const int iColWidth = 60, iColSpace = 25, iMaxHeight = 400,
              iHeightSpace = 25, iXLegendSpace = 30, iTitleSpace = 50;
    int iMaxWidth = (iColWidth + iColSpace) * aX.Count + iColSpace,
        iMaxColHeight = 0, iTotalHeight = iMaxHeight + iXLegendSpace + iTitleSpace;

    Bitmap objBitmap = new Bitmap(iMaxWidth, iTotalHeight);
    Graphics objGraphics = Graphics.FromImage(objBitmap);

    objGraphics.FillRectangle(new SolidBrush(Color.White),
                              0, 0, iMaxWidth, iTotalHeight);
    objGraphics.FillRectangle(new SolidBrush(Color.Ivory),
                              0, 0, iMaxWidth, iMaxHeight);

    // find the maximum value
    foreach (int iValue in aY)
       if (iValue > iMaxColHeight) iMaxColHeight = iValue;


    int iBarX = iColSpace, iCurrentHeight;
    SolidBrush objBrush = new SolidBrush(Color.FromArgb(70,20,20));
    Font fontLegend = new Font("Arial", 11),
         fontValues = new Font("Arial", 8),
         fontTitle = new Font("Arial", 24);

    // loop through and draw each bar
    for (int iLoop=0; iLoop < aX.Count; iLoop++)
    {
      iCurrentHeight = (int) ((Convert.ToDouble(aY[iLoop].ToString()) / Convert.ToDouble(iMaxColHeight)) * Convert.ToDouble((iMaxHeight - iHeightSpace)));

      objGraphics.FillRectangle(objBrush, iBarX, iMaxHeight - iCurrentHeight, iColWidth, iCurrentHeight);
      objGraphics.DrawString(aX[iLoop].ToString(), fontLegend, objBrush, iBarX, iMaxHeight);
      objGraphics.DrawString(String.Format("{0:#,###}", (int) aY[iLoop]), fontValues, objBrush, iBarX, iMaxHeight - iCurrentHeight - 15);

      iBarX += (iColSpace + iColWidth);
    }

    objGraphics.DrawString(strTitle, fontTitle, objBrush, 
                           (iMaxWidth / 2) - strTitle.Length * 6, iMaxHeight + iXLegendSpace);
    objBitmap.Save("C:\\inetpub\\wwwroot\\graph.gif", ImageFormat.Gif);
 

    objGraphics.Dispose();
    objBitmap.Dispose();
  }


  void Page_Load(Object sender, EventArgs e)
  {

    ArrayList aMonths = new ArrayList(),
              aProfits = new ArrayList();
    aMonths.Add("January");
    aMonths.Add("February");
    aMonths.Add("March");
    aMonths.Add("April");
    aMonths.Add("May");

    aProfits.Add(240500);
    aProfits.Add(220950);
    aProfits.Add(283500);
    aProfits.Add(340000);
    aProfits.Add(325750);

    DrawBarGraph("Profits!", aMonths, aProfits);

  }
</script>