<script language="C#" runat="server">
  void Page_Load(Object sender, EventArgs e)
  {
    // Display information about the xspwp.exe process
    ProcessInfo objProcInfo = ProcessModelInfo.GetCurrentProcessInfo();

    lblStartTime.Text = objProcInfo.StartTime.ToString();
    lblAge.Text = String.Format("{0:0.##}", Convert.ToSingle(objProcInfo.Age.TotalHours)) + " hours";
    switch (objProcInfo.Status)
    {
      case ProcessStatus.Alive:
        lblStatus.Text = "Alive";
        break;
      case ProcessStatus.ShutDown:
        lblStatus.Text = "Shut down";
        break;
      case ProcessStatus.ShuttingDown:
        lblStatus.Text = "Currently shutting down";
        break;
      case ProcessStatus.Terminated:
        lblStatus.Text = "Terminated";
        break;
    }

    lblProcessID.Text = objProcInfo.ProcessID.ToString();
    lblPeakMemoryUsed.Text = String.Format("{0:#,###}", objProcInfo.PeakMemoryUsed) + " K";
  }
</script>

<html>
<body>
    <table align="center" border="1" cellspacing="0" cellpadding="5">
      <tr>
        <th colspan=2>
          <code>aspnet_wp.exe</code> Process Information
        </th>
      </tr>
      <tr>
        <td>Start Time</td>
        <td><asp:label runat="server" id="lblStartTime" /></td>
      </tr>
      <tr>
        <td>Age</td>
        <td><asp:label runat="server" id="lblAge" /></td>
      </tr>
      <tr>
        <td>Status</td>
        <td><asp:label runat="server" id="lblStatus" /></td>
      </tr>
      <tr>
        <td>ProcessID</td>
        <td><asp:label runat="server" id="lblProcessID" /></td>
      </tr>
      <tr>
        <td>Peak Memory Used</td>
        <td><asp:label runat="server" id="lblPeakMemoryUsed" /></td>
      </tr>
    </table>
</body>
</html>