<script language="VB" runat="server">
  Sub Page_Load(sender as Object, e as EventArgs)
    Dim iCount as Integer = 10

    If Not Page.IsPostBack Then
      'View the last 10 restart reasons
      txtCount.Text = iCount
    Else
      'View the recounts defined by txtCount
      iCount = Convert.ToInt32(txtCount.Text)
    End If

    'Display the reasons for the last iCount restarts
    Dim aProcInfos() as ProcessInfo = ProcessModelInfo.GetHistory(iCount)
    Dim objProcInfo as ProcessInfo

    lblProcHistory.Text = ""
    For Each objProcInfo in aProcInfos
      lblProcHistory.Text &= "<b>Process " & objProcInfo.ProcessID & _
         "</b><br><li>Started At: " & objProcInfo.StartTime & "<br>" & _
         "<li>Duration: " & _
         String.Format("{0:0.##}", objProcInfo.Age.TotalHours) & " hours<br>" & _
         "<li>Shutdown Reason: " & DisplayReason(objProcInfo.ShutdownReason) & _
         "<p>"
    Next

    Dim objCurrentProc as ProcessInfo = ProcessModelInfo.GetCurrentProcessInfo()
    lblCurrentProc.Text = "<i>The current process is running under Process ID " & _
         objCurrentProc.ProcessID & "</i>"
  End Sub

  Function DisplayReason(enumReason as ProcessShutdownReason) as String
    Select Case enumReason
      Case ProcessShutdownReason.IdleTimeout:
         DisplayReason = "Idle Timeout"
      Case ProcessShutdownReason.MemoryLimitExceeded:
         DisplayReason = "Memory Limit Exceeded"
      Case ProcessShutdownReason.None:
         DisplayReason = "None"
      Case ProcessShutdownReason.RequestQueueLimit:
         DisplayReason = "Request Queue Limit"
      Case ProcessShutdownReason.RequestsLimit:
         DisplayReason = "Requests Limit"
      Case ProcessShutdownReason.Timeout:
         DisplayReason = "Timeout"
      Case ProcessShutdownReason.Unexpected:
         DisplayReason = "Unknown"
    End Select
  End Function
</script>

<html>
<body>
  <form runat="server">
    <h1>Process Restart Reasons</h1>
    View last
    <asp:textbox id="txtCount" runat="server" Size="3" />
    restart reasons.
    <asp:button id="btnSubmit" runat="server" Text="View Reasons" />
    <hr>
    <asp:label runat="server" id="lblProcHistory" />
    <hr><asp:label id="lblCurrentProc" runat="server" />
  </form>
</body>
</html>