<script language="C#" runat="server">
  void Page_Load(Object sender, EventArgs e)
  {
    int iCount = 10;

    if (!Page.IsPostBack)
      // View the last 10 restart reasons
      txtCount.Text = iCount.ToString();
    else
      // View the recounts defined by txtCount
      iCount = Convert.ToInt32(txtCount.Text);

    // Display the reasons for the last iCount restarts
    ProcessInfo[] aProcInfos = ProcessModelInfo.GetHistory(iCount);

    lblProcHistory.Text = "";
    foreach (ProcessInfo objProcInfo in aProcInfos)
      lblProcHistory.Text += "<b>Process " + objProcInfo.ProcessID.ToString() +
         "</b><br><li>Started At: " + objProcInfo.StartTime.ToString() + "<br>" +
         "<li>Duration: " + String.Format("{0:0.##}", Convert.ToSingle(objProcInfo.Age.TotalHours)) + " hours<br>" +
         "<li>Shutdown Reason: " + DisplayReason(objProcInfo.ShutdownReason) +
         "<p>";


    ProcessInfo objCurrentProc = ProcessModelInfo.GetCurrentProcessInfo();
    lblCurrentProc.Text = "<i>The current process is running under Process ID " +
         objCurrentProc.ProcessID.ToString() + "</i>";
  }

  String DisplayReason(ProcessShutdownReason enumReason)
  {
    String strMessage = "";

    switch (enumReason)
    {
      case ProcessShutdownReason.IdleTimeout:
         strMessage = "Idle Timeout";
         break;
      case ProcessShutdownReason.MemoryLimitExceeded:
         strMessage = "Memory Limit Exceeded";
         break;
      case ProcessShutdownReason.None:
         strMessage = "None";
         break;
      case ProcessShutdownReason.RequestQueueLimit:
         strMessage = "Request Queue Limit";
         break;
      case ProcessShutdownReason.RequestsLimit:
         strMessage = "Requests Limit";
         break;
      case ProcessShutdownReason.Timeout:
         strMessage = "Timeout";
         break;
      case ProcessShutdownReason.Unexpected:
         strMessage  = "Unknown";
         break;
    }

    return strMessage;
  }
</script>

<html>
<body>
  <form runat="server">
    <h1>Process Restart Reasons</h1>
    View last
    <asp:textbox id="txtCount" runat="server" Size="3" />
    restart reasons.
    <asp:button id="btnSubmit" runat="server" Text="View Reasons" />
    <hr>
    <asp:label runat="server" id="lblProcHistory" />
    <hr><asp:label id="lblCurrentProc" runat="server" />
  </form>
</body>
</html>