<%@ Import Namespace="System.Diagnostics" %>
<%@ Import Namespace="System.Drawing" %>
<script language="c#" runat="server">
  void Page_Load(Object sender, EventArgs e)
  {
    if (!Page.IsPostBack)
       DisplayEventLog("System");
  }


  void btnSubmit_OnClick(Object sender, EventArgs e)
  {
    DisplayEventLog(lstLog.SelectedItem.Value);
  }


  void btnClear_OnClick(Object sender, EventArgs e)
  {
    // Clear all of the event log entries
    EventLog objEventLog = new EventLog(lstLog.SelectedItem.Value);
    objEventLog.Clear();
  }


  void DisplayEventLog(String strLogName)
  {
    TableRow objRow = new TableRow();
    TableCell objCell = new TableCell();

    objCell.BackColor = Color.Bisque;
    objCell.HorizontalAlign = HorizontalAlign.Center;
    objCell.Text = "Type";
    objRow.Cells.Add(objCell);

    objCell = new TableCell();
    objCell.BackColor = Color.Bisque;
    objCell.HorizontalAlign = HorizontalAlign.Center;
    objCell.Text = "Date";
    objRow.Cells.Add(objCell);

    objCell = new TableCell();
    objCell.BackColor = Color.Bisque;
    objCell.HorizontalAlign = HorizontalAlign.Center;
    objCell.Text = "Time";
    objRow.Cells.Add(objCell);

    objCell = new TableCell();
    objCell.BackColor = Color.Bisque;
    objCell.HorizontalAlign = HorizontalAlign.Center;
    objCell.Text = "Source";
    objRow.Cells.Add(objCell);

    objCell = new TableCell();
    objCell.BackColor = Color.Bisque;
    objCell.HorizontalAlign = HorizontalAlign.Center;
    objCell.Text = "User";
    objRow.Cells.Add(objCell);

    objCell = new TableCell();
    objCell.BackColor = Color.Bisque;
    objCell.HorizontalAlign = HorizontalAlign.Center;
    objCell.Text = "Computer";
    objRow.Cells.Add(objCell);

    tblLog.Rows.Add(objRow);


    EventLog objEventLog = new EventLog(strLogName);
    foreach (EventLogEntry objEntry in objEventLog.Entries)
    {
      objRow = new TableRow();
      objCell = new TableCell();

      // Determine the type of error
      if (objEntry.EntryType == EventLogEntryType.Error)
      {
        objCell.BackColor = Color.Red;
        objCell.ForeColor = Color.White;
        objCell.Text = "Error";
      }
       else if (objEntry.EntryType == EventLogEntryType.Information)
      {
        objCell.Text = "Information";
      }
       else if (objEntry.EntryType == EventLogEntryType.Warning)
      {
        objCell.BackColor = Color.Yellow;
        objCell.Text = "Warning";
      }
       else if (objEntry.EntryType == EventLogEntryType.SuccessAudit)
      {
        objCell.Text = "Success Audit";
      }
       else if (objEntry.EntryType == EventLogEntryType.FailureAudit)
      {
        objCell.ForeColor = Color.Red;
        objCell.Text = "Failure Audit";
      }
      objCell.HorizontalAlign = HorizontalAlign.Center;
      objRow.Cells.Add(objCell);

      objCell = new TableCell();
      objCell.Text = objEntry.TimeGenerated.ToShortDateString();
      objRow.Cells.Add(objCell);

      objCell = new TableCell();
      objCell.Text = objEntry.TimeGenerated.ToLongTimeString();
      objRow.Cells.Add(objCell);

      objCell = new TableCell();
      objCell.Text = objEntry.Source;
      objRow.Cells.Add(objCell);

      objCell = new TableCell();
      if (objEntry.UserName != null)
        objCell.Text = objEntry.UserName;
      else
        objCell.Text = "N/A";

      objRow.Cells.Add(objCell);

      objCell = new TableCell();
      objCell.Text = objEntry.MachineName;
      objRow.Cells.Add(objCell);

      tblLog.Rows.Add(objRow);
    }
  }
</script>

<html>
<body>
  <form runat="server">

    <h1>Event Log Viewer</h1>
    <asp:listbox runat="server" id="lstLog" Rows="1">
      <asp:listitem>Application</asp:listitem>
      <asp:listitem>Security</asp:listitem>
      <asp:listitem Selected="True">System</asp:listitem>
    </asp:listbox>
    <asp:button runat="server" id="btnSubmit" Text="Display Event Log"
                OnClick="btnSubmit_OnClick" />

    <hr>

    <asp:table runat="server" id="tblLog" CellPadding="5"
               CellSpacing="0" GridLines="Both" Font-Size="10pt"
               Font-Name="Verdana" />
    <hr>
    <asp:button runat="server" id="btnClear" Text="Clear Event Log"
                 OnClick="btnClear_OnClick" />
  </form>
</body></html>