<script language="c#" runat="server">
  void btnSubmit_Click(Object sender, EventArgs e)
  {
    Double dblValue = 0.0, dblPrincipal = 0.0;
    int iYears = 0;

    if (Page.IsValid)
    {
      iYears = Convert.ToInt32(txtRetireAge.Text) - Convert.ToInt32(txtAge.Text);
      dblPrincipal = Convert.ToSingle(txtSavings.Text);
      dblValue = dblPrincipal * Math.Exp((float) iYears * 0.06);

      lblResults.Text = "Your savings will be worth " + String.Format("{0:c}", dblValue) +
                   " when you retire.";
    }
  }
</script>

<html>
<body>
  <form method="post" runat="server">
    <h1>Retirement Calculator</h1>
    How old are you?
    <asp:textbox id="txtAge" runat="server" Columns="3" />
    <asp:RangeValidator runat="server"
           id="rngAge" Type="Integer" MinimumValue="0"
           MaximumValue="90"
           ControlToValidate="txtAge" Display="Dynamic"
           ErrorMessage="Age must be between 0 and 90." />

    <br>When do you expect to retire?
    <asp:textbox id="txtRetireAge" runat="server" Columns="3" />
    <asp:RangeValidator runat="server"
           id="rngRetireAge" Type="Integer"
           ControlToValidate="txtRetireAge" Display="Dynamic"
           MinimumValue="0" MaximumValue="100"
           ErrorMessage="Retirement age must be between current age and 100." />
    <asp:CompareValidator runat="server"
           id="compRetireAge" Type="Integer" Operator="GreaterThanEqual"
           ControlToValidate="txtRetireAge" Display="Dynamic"
           ControlToCompare="txtAge"
           ErrorMessage="Your projected retirement age must be >= to your Age." />

    <br>How much do you have in a 6% CD?
    $<asp:textbox id="txtSavings" runat="server" />
    <asp:CompareValidator runat="server"
           id="compSavigs" Type="Currency" Operator="DataTypeCheck"
           ControlToValidate="txtSavings" Display="Dynamic"
           ErrorMessage="Savings must be an currency value." />
    <asp:CompareValidator runat="server"
           id="compSavigsMinimum" Type="Currency" Operator="GreaterThanEqual"
           ControlToValidate="txtSavings" ValueToCompare="0"
           Display="Dynamic"
           ErrorMessage="You must have at least 0 dollars saved!" />

    <p><asp:button id="btnSubmit" runat="server"
            OnClick="btnSubmit_Click" Text="Calculate Retirement Monies" />
    <p><asp:label runat="server" id="lblResults" />
  </form>
</body>
</html>