<script language="vb" runat="server">
  Sub btnSubmit_Click(sender as Object, e as EventArgs)
    If Page.IsValid then
      Response.Write("You entered a valid credit card number.")
    Else
      Response.Write("You entered an <b>invalid</b> credit card number.")
    End If
  End Sub


  Sub CreditCardCheck(sender as Object, args as ServerValidateEventArgs)
    Dim iLoop, iTotal, iTmpDoubling as Integer
    Dim strCreditCard as String = args.Value

    'Make sure we're between 13 and 16 digits
    If strCreditCard.Length < 13 or strCreditCard.Length > 16 then
      args.IsValid = False
      Exit Sub
    End If

    iLoop = strCreditCard.Length - 2
    iTotal += CInt(strCreditCard.Substring(iLoop+1,1))
    While iLoop >= 0
      'Double the current digit
      iTmpDoubling = CInt(strCreditCard.Substring(iLoop,1)) * 2

      iTotal += iTmpDoubling mod 10
      If iTmpDoubling >= 10 then iTotal += 1
     
      iLoop -= 1   'Move one digit to the left

      If iLoop >= 0 Then
        iTotal += CInt(strCreditCard.Substring(iLoop,1))
        iLoop -= 1   'Move one digit to the left
      End If
    End While

    'Return true if the number is evenly divisible by 10, false otherwise
    args.IsValid = (iTotal mod 10 = 0)
    
  End Sub
</script>

<html>
<body>
  <form method="post" runat="server">
    <h1>Enter Your Credit Card Information</h1>
    Enter your Credit Card Number:
    <asp:textbox id="txtCreditCardNumber" runat="server" />
    <asp:CustomValidator runat="server" id="custCreditCardVal"
          ControlToValidate="txtCreditCardNumber"
          OnServerValidate="CreditCardCheck" Display="Dynamic"
          ErrorMessage="Invalid Credit Card Number" />

    <p><asp:button id="btnSubmit" runat="server"
            OnClick="btnSubmit_Click" Text="Calculate Retirement Monies" />
    <p><asp:label runat="server" id="lblResults" />
  </form>
</body>
</html>