<script language="c#" runat="server">
  void btnSubmit_Click(Object sender, EventArgs e)
  {
    if (Page.IsValid)
      Response.Write("You entered a valid credit card number.");
    else
      Response.Write("You entered an <b>invalid</b> credit card number.");
  }


  void CreditCardCheck(Object sender, ServerValidateEventArgs args)
  {
    int iLoop, iTotal = 0, iTmpDoubling;
    String strCreditCard = args.Value;

    // Make sure we're between 13 and 16 digits
    if (strCreditCard.Length < 13 || strCreditCard.Length > 16)
    {
      args.IsValid = false;
      return;
    }

    iLoop = strCreditCard.Length - 2;
    iTotal += Convert.ToInt32(strCreditCard.Substring(iLoop+1,1));
    while (iLoop >= 0)
    {
      // Double the current digit
      iTmpDoubling = Convert.ToInt32(strCreditCard.Substring(iLoop,1)) * 2;

      iTotal += iTmpDoubling % 10;
      if (iTmpDoubling >= 10) iTotal++;
     
      iLoop--;   // Move one digit to the left

      if (iLoop >= 0)
      {
        iTotal += Convert.ToInt32(strCreditCard.Substring(iLoop,1));
        iLoop--;   // Move one digit to the left
      }
    }

    // Return true if the number is evenly divisible by 10, false otherwise
    args.IsValid = (iTotal % 10 == 0);
    
  }
</script>

<html>
<body>
  <form method="post" runat="server">
    <h1>Enter Your Credit Card Information</h1>
    Enter your Credit Card Number:
    <asp:textbox id="txtCreditCardNumber" runat="server" />
    <asp:CustomValidator runat="server" id="custCreditCardVal"
          ControlToValidate="txtCreditCardNumber"
          OnServerValidate="CreditCardCheck" Display="Dynamic"
          ErrorMessage="Invalid Credit Card Number" />

    <p><asp:button id="btnSubmit" runat="server"
            OnClick="btnSubmit_Click" Text="Calculate Retirement Monies" />
    <p><asp:label runat="server" id="lblResults" />
  </form>
</body>
</html>